alias camera {
  var %s = %drw.win $1 $2 %drw.cen.x %drw.cen.y $3 %rmeth %drw.rnorms %drw.shwn $4 %obj0matrix $5-
  if (!$window(@buf)) {
    window -phBnd +d @buf 0 0 %drw.w %drw.h
    ; drawrect -nf @buf 1 1 0 0 %drw.w %drw.h
  }
  dll meshview.dll dobjbuf @buf %s $did(mbuild,231) $did(mbuild,241)
}
alias diacam2 {
  var %c = $anycolor($did(mbuild,281))
  if (!%c) %c = $anycolor($color_read($1))
  if (!%c) %c = $anycolor($did(mbuild,281))
  camera %c $doubletcast($did(mbuild,282)) %dr.curob $&
    $angle2fol($did(mbuild,201)) $did(mbuild,260) $did(mbuild,200) $did(mbuild,202)
}
; camera color, size, object-id, focal-length, translate, cam-pos, light-pos
; 1-3 %rmeth
; options: draw-points-only wireframe render
; REverse norms
; shwnums 0-3 = off front back both
alias drawnobjs {
  if (($did(mbuild,223)) || ($did(mbuild,223) == 0)) drawbg $did(mbuild,223)
  else if (($did(mbuild,225).state) && (%drw.bgimg)) drawimgbg
  else drawbg
  diacam2 %dr.curob
  camd %obj0matrix
  matrixdis %obj0matrix
  drawdot %drw.win
  close -@ @buf
  window -a %drw.win
}
alias camerror {
  if ($gettok($did(mbuild,200),3,32) > -1.0) {
    _e Error in camera position : Z must be less than 0. Load defaults or try the Look button
    halt
  }
  if (!%drw.dialog) {
    _e Error: need dialog
    halt
  }
}
alias drawbg {
  var %c = $1-
  if (!%c) %c = 14
  drawrect -nrf %drw.win $anycolor(%c) 1 0 0 %drw.w %drw.h
}
alias anycolor {
  ; (any color, gl, rgb, single or 3 spaced or comma)
  if ($len($1-) < 3) return $mcol2rgb($1)
  if (. isin $1-) return $gl2rgb($1-)
  if (($numtok($1-,32) == 3) || ($numtok($1-,44) == 3)) return $_rgb($1-)
  return $1
}
alias drawing {
  drawnobjs
  ; camd %obj0matrix
  ; drawdot %drw.win
}
alias matrixdis {
  ; (m)
  var %x = %drw.w - 130
  var %y = %drw.h - 20
  var %s = $radec($1-).rd $_z($1-)
  tokenize 32 %s
  %s = $2 $1 $3
  drawtext -nob %drw.win 0 1 Arial 13  %x %y %s
}
alias lookat {
  %cmatrix = 1.0 0.0 0.0 0.0 1.0 0.0 0.0 0.0 1.0
  var %p = $did(mbuild,260), %campos = $did(mbuild,200)
  var %view = $subv($did(mbuild,198),%campos)
  if (!$vlen(%view)) %view = 0.0 0.0 1.0
  ; lookat<-campos :set world matrix to 'look-at' field
  aview %view
  ; distance objpos<-campos
  var %len = $vlen($subv(%p,%campos))
  if (%len < 1.0) halt
  var %l, %u, %e, %m, %om = %obj0matrix

  %u = $gettok(%cmatrix,4-6,32)
  %e = $normalize($subv(%p,%campos))
  %l = $normalize($crossprod(%u,%e))
  %u = $normalize($crossprod(%e,%l))
  %m = %l %u %e
  %m = $invt(%m)
  %om = $multm3(%om,%m)
  if (0) {
    ; cam gimbal
    %camrotv = 0 $deg2rad(2) 0
    %cmatrix = $gimbalmatrix(%cmatrix)
    %wmatrix = $invt(%cmatrix)
  }
  var %v = %campos
  if (%drw.zoom) %v = %drw.zoom
  var %objp = $tw2s($poptmatrix($subv(%p,%v),%wmatrix))
  ; %objp = $camera(%p)

  if (%objp) {
    if (($did(mbuild,223)) || ($did(mbuild,223) == 0)) drawbg $did(mbuild,223)
    else if (($did(mbuild,225).state) && (%drw.bgimg)) drawimgbg
    else drawbg
    var %c = $anycolor($did(mbuild,281))
    if (!%c) %c = $anycolor($color_read($1))
    if (!%c) %c = $anycolor($did(mbuild,281))
    tokenize 32 %c $doubletcast($did(mbuild,282)) %dr.curob $angle2fol($did(mbuild,201)) $&
      0.0 0.0 0.0 0.0 0.0 $calc(%len * -1) $poptmatrix($did(mbuild,202),%wmatrix)))
    ; $did(mbuild,260)  translateVector(mesh-pos) available 

    var %s = %drw.win $1 $2 %objp $3 %rmeth %drw.rnorms %drw.shwn $4 %om $5-
    if (!$window(@buf)) {
      window -phBnd +d @buf 0 0 %drw.w %drw.h
      ; drawrect -nf @buf 1 1 0 0 %drw.w %drw.h
    }
    dll meshview.dll dobjbuf @buf %s $did(mbuild,231) $did(mbuild,241)
    ;  b-win v-win color, size, 2d-pos, object-id, method, rnorms, nums, focal-length, M, translate,
    ; cam-pos/negative dist to render, light-pos, intensity, ambience
    camd %obj0matrix
    matrixdis %obj0matrix
    drawdot %drw.win
    close -@ @buf
    window -a %drw.win
  }
}
alias tw2s {
  var %fol = $angle2fol($did(mbuild,201))
  tokenize 32 $1-
  if ($3 < 0) return 0
  return $int($calc(((%fol / $3) * $1) + %drw.cen.x)) $int($calc(((%fol / $3) * $2) + %drw.cen.y))
}
alias aview {
  ; align matrix eye to (v)
  var %eye = $gettok(%cmatrix,7-9,32), %up = $gettok(%cmatrix,4-6,32)
  var %l, %teye = $normalize($1-)
  ; add a divv of the difference for smoothtrans
  ; %eye = $addv(%eye,$divv($subv(%teye,%eye),1.8))
  ; %eye = $NORMALIZE(%eye)
  %eye = %teye
  if ($vequal(%up,%eye)) %up = $addv(%up,0.0 0.0 -0.002)
  %l = $NORMALIZE($CROSSPROD(%up,%eye))
  %up = $NORMALIZE($CROSSPROD(%eye,%l))
  %cmatrix = %l %up %eye
  %wmatrix = $vrnd6($invt(%cmatrix))
}
alias vequal {
  tokenize 32 $normalize($1) $normalize($2)
  if (($abs($1) == $abs($4)) && ($abs($2) == $abs($5)) && ($abs($3) == $abs($6))) return 1
  return 0
}
alias gimbalmatrix {
  ; (matrix)
  ; 10 = not axis rot
  var %ten = $_!($did(mbuild,999).state)
  var %up = $gettok($1-,4-6,32), %eye = $gettok($1-,7-9,32), %v = %eye
  ; %camrotv = $rep0.0(%camrotv) 0 must be 0 not 0.0
  tokenize 32 %camrotv
  if (%ten) %v = 0.0 0.0 1.0
  if ($3) {
    %up = $lrotation($3, %v, %up)
    if (%ten) %eye = $lrotation($3, %v, %eye)
  }
  %v = %up
  if (%ten) %v = 0.0 1.0 0.0
  if ($2) {
    %eye = $lrotation($2, %v, %eye)
    if (%ten) %up = $lrotation($2, %v, %up)
  }
  if ($1) {
    %v = $normalize($CROSSPROD(%up,%eye))
    if (%ten) %v = 1.0 0.0 0.0
    %eye = $lrotation($1, %v, %eye)
    %up = $lrotation($1, %v, %up)
  }
  %v = $NORMALIZE($CROSSPROD(%up,%eye))
  %up = $NORMALIZE($CROSSPROD(%eye, %v))
  %eye = $NORMALIZE($CROSSPROD(%v,%up))

  %camrotv = 0 0 0
  return %v %up %eye
  ; 0.0 0.0 0.0
}
alias gimbal_t_matrix {
  ; (matrix 3x3, rotv, [axis]).tru .given .maxis(default)
  ; 10 = not axis rot
  var %ten = 0
  if ($prop == tru) %ten = 1
  ; = $_!($did(mbuild,999).state)
  var %up = $gettok($1-,4-6,32), %eye = $gettok($1-,7-9,32), %v = %eye
  ; %camrotv = $rep0.0(%camrotv) 0 must be 0 not 0.0
  var %ax = $3
  tokenize 32 $2
  if ($3) {
    if ($prop == given) %v = %ax
    else if (%ten) %v = 0.0 0.0 1.0
    %up = $lrotation($3, %v, %up)
    if ((%ten) || ($prop == given)) %eye = $lrotation($3, %v, %eye)
  }
  if ($2) {
    %v = %up
    if ($prop == given) %v = %ax
    else if (%ten) %v = 0.0 1.0 0.0
    %eye = $lrotation($2, %v, %eye)
    if ((%ten) || ($prop == given)) %up = $lrotation($2, %v, %up)
  }
  if ($1) {
    %v = $normalize($CROSSPROD(%up,%eye))
    if ($prop == given) %v = %ax
    else if (%ten) %v = 1.0 0.0 0.0
    %eye = $lrotation($1, %v, %eye)
    %up = $lrotation($1, %v, %up)
  }
  %v = $NORMALIZE($CROSSPROD(%up,%eye))
  %up = $NORMALIZE($CROSSPROD(%eye, %v))
  %eye = $NORMALIZE($CROSSPROD(%v,%up))

  %camrotv = 0 0 0
  return %v %up %eye
  ; 0.0 0.0 0.0
}
alias defload {
  did -o mbuild 200 1 0.0 0.0 -1000.0
  did -o mbuild 201 1 24
  did -o mbuild 202 1 0.0 -1000.0 -1000.0
  did -o mbuild 198 1 0.0 0.0 0.0
  ; did -o mbuild 241 1 0 
  ; did -o mbuild 231 1 0
  did -o mbuild 260 1 0.0 0.0 0.0
  did -o mbuild 281 1 6519808
  ; did -o mbuild 282 1 1
  if (0) {
    Position 200 cam
    FOV
    Light 202
    Look
    Intensity
    Ambience
    Position 260
    Color
    Size
  }
}
alias edit_ini_set {
  ; (file) remote.ini
  var %r
  var %read = 1, %i = 0
  if ($1) {
    while (%read) {
      inc %i
      %read = $readini($1,n,variables,$+(n,%i))
      if (%read) {
        %r = $gettok($right(%read,-1),1,32)
        % [ $+ [ %r ] ] = $gettok(%read,2-,32)
        e %r
      }
    }
    _e Finished Reading $1
  }
}
alias varcopy {
  ; (filename) -edi.ini
  var %f = $did(mbuild,360).text, %q = 1
  if (!$1) {
    if ($did(mbuild,300).lines) %n = $did(mbuild,360).lines
    tokenize 32 $did(mbuild,360).text
    if ($1) {
      if ($not_there($1,%n,360)) did -o mbuild 360 $calc(%n + 1) $1
    }
    else {
      %f = $$?="Enter filename for %drw.pni pnts"
      ; e $not_there(%f,%n,360)
      if ($not_there(%f,%n,360)) did -o mbuild 360 $calc(%n + 1) %f
    }
  }
  else if ($1) %f = $1)
  if (%f) {
    var %f = $+(%f,edi.ini)

    if ($exists(%f)) %q = $?!="Overwrite %f with all existing vars?"
    if (%q) {
      copy -o remote.ini %f
      _e File Saved as %f
    }
  }
  else _e Need a filename, bottom combo
}
alias load_obj_combo {
  sortwin
  var %i = 0, %f, %n = $findfile($mircdir,*pnt.txt,0)
  ; clear text in combo
  did -r mbuild 300
  while (%i < %n) {
    inc %i
    %f = $left($nopath($findfile($mircdir,*pnt.txt,%i)),-7)
    if (%f) aline @sort %f
    ; did -o mbuild 300 %i %f
  }
  sort2combo 300
  close -@ @sort
}
alias load_ini_combo {
  var %i = 0, %f, %n = $findfile($mircdir,*edi.ini,0)
  did -r mbuild 360
  while (%i < %n) {
    inc %i
    %f = $left($nopath($findfile($mircdir,*edi.ini,%i)),-7)
    did -o mbuild 360 %i %f
  }
}
alias load_mem_ini {
  var %f = $did(mbuild,360).text
  if (%f) {
    %f = $+(%f,edi.ini)
    edit_ini_set %f
  }
}
alias load_mem_obj {
  var %f = $did(mbuild,300).text, %nz = 0.0
  var %nam = %f
  if (%f) {
    %f = $+(%f,pnt.txt)
    var %i = 0, %p, %n = $lines(%f)
    if (01) {
      while (%i < %n) {
        inc %i
        %p = $read(%f,%i)
        dec %nz $gettok(%p,3,32)
      }
      %nz = %nz / %n
    }
    %i = 0
    %nz = %drw.cen.x %drw.cen.y %nz
    % [ $+ [ $+(%nam,fcntr) ] ] = %nz
    while (%i < %n) {
      inc %i
      %p = $read(%f,%i)
      %p = $addv(%p,%nz)
      %edit_ [ $+ [ %i ] ] = $vrnd6(%p)
    }
    %drw.pni = %n
    _e Finished Reading %f

    %drw.edmode = 3
    %clk.cap = $checksel
    rangeset
    drawbg 1
    drawe_range 7 2 $did(mbuild,%clk.cap)
    ; color size [ range ] default to pni
    drawdot %drw.win
  }
}

alias rrtest {
  %drw.edmode = 3
  %clk.cap = $checksel
  rangeset
  e %clk.cap
  e $did(mbuild,%clk.cap)

}
alias sort2combo {
  ; (id)
  var %i = 0, %n = $line(@sort,0,0), %dn = $did(mbuild,$1).lines
  while (%i < %n) {
    inc %i
    did -o mbuild $1 $calc(%i + %dn) $line(@sort,%i,0)
  }
}

alias fov {
  var %n = %drw.cen.x
  var %p3 = $calc(%n * -1) 0 0
  var %p2 = %n 0 0
  var %p = 0 0 $angle2fol($did(mbuild,201))
  return $angle(%p,%p2,%p3)
}
alias angle2fol {
  var %a = $deg2rad($calc((180 - $clamp($1,0.001,179.6)) / 2))
  return $int($asa-sin(%PI.5,%drw.cen.x,%a))
}
alias load_drop_combo {
  var %i = 0, %f, %n = $pov-col(0)
  did -r mbuild 503
  while (%i < %n) {
    inc %i
    %f = $pov-col(%i)
    did -o mbuild 503 %i %f
  }
}
alias load_gdrop_combo {
  var %i = 0, %f, %n = $gpov-col(0)
  did -r mbuild 504
  while (%i < %n) {
    inc %i
    %f = $gpov-col(%i)
    did -o mbuild 504 %i %f
  }
}
alias cam1 {
  ; look
  did -o mbuild 498 1 0.0 0.0 0.0
  ; position
  did -o mbuild 510 1 0.0 9.0 -20.0
  did -o mbuild 511 1 67.4
}
alias cam2 {
  ; look
  did -o mbuild 498 1 0.0 0.0 0.0
  ; position
  did -o mbuild 510 1 0.0 0.0 -60.0
  did -o mbuild 511 1 24
}
alias clear_light_dis {
  var %i = 600, %n = 608
  while (%i < %n) {
    inc %i
    did -r mbuild %i
  }
}
alias remove_light {
  var %l = $did(mbuild,600).seltext
  if (%l) {
    did -r mbuild 600
    var %i = 0, %j = 0, %n = $numtok($1-,58)
    while (%i < %n) {
      inc %i
      if ($gettok($1-,%i,58) != %l) {
        inc %j
        did -o mbuild 600 %j $gettok($1-,%i,58)
      }
    }
  }
}
alias lightcombo {
  ; (light strng)
  did -r mbuild 600
  var %i = 0, %n = $numtok($1-,58)
  while (%i < %n) {
    inc %i
    did -o mbuild 600 %i $gettok($1-,%i,58)
  }
}
alias camcombo {
  did -r mbuild 502
  var %i = 0, %n = $numtok(%drw.cameras,58)
  while (%i < %n) {
    inc %i
    did -o mbuild 502 %i $gettok(%drw.cameras,%i,58)
  }
}
alias light_load {
  if (!$1) halt
  clear_light_dis
  var %f = $+($scriptdir,$1,.txt), %t, %s = <:spotlight:color:point_at:fade_distance:radius:fade_power:falloff:
  var %r, %j = 0, %id, %i = 0, %n = $lines(%f), %nt = $numtok(%s,58)
  if (!$exists(%f)) { _e %f not found (light_load) | halt }
  while (%i < %n) {
    inc %i
    %r = $read(%f,n,%i)
    %j = 0
    while (%j < %nt) {
      inc %j
      if ((< !isin %r) && (!$gettok(%r,2,32)) && (%i < %n)) %id = 602
      else if ($gettok(%s,%j,58) isin $gettok(%r,1,32)) %id = $+(6,$pad(%j,2,0))
    }
    %t = $gettok(%r,2,32)
    if (%id == 602) %t = %r
    if (%id == 601) %t = $remove($replace(%r,$chr(44),$chr(32)),<,>)
    if (%id == 604) %t = $remove($replace(%t,$chr(44),$chr(32)),<,>)
    if (%id) did -o mbuild %id 1 %t
    %id = $null
  }
}
alias save_light {
  var %d = $_?(light_save,Enter Light Name)
}
alias light_save {
  var %f = $+($scriptdir,$1,.txt), %name = $1
  write -c %f
  write %f light_source $chr(123)
  if ($did(mbuild,601)) {
    tokenize 32 $did(mbuild,601)
    write %f $+(<,$1,$chr(44),$2,$chr(44),$3,>)
  }
  if ($did(mbuild,603)) write %f color $did(mbuild,603)
  if ($did(mbuild,602)) write %f $did(mbuild,602)
  if ($did(mbuild,604)) {
    tokenize 32 $did(mbuild,604)
    write %f point_at $+(<,$1,$chr(44),$2,$chr(44),$3,>)
  }
  if ($did(mbuild,605)) write %f fade_distance $did(mbuild,605)
  if ($did(mbuild,606)) write %f radius $did(mbuild,606)
  if ($did(mbuild,607)) write %f fade_power $did(mbuild,607)
  if ($did(mbuild,608)) write %f falloff $did(mbuild,608)
  write %f $chr(125)

  if ($not_there(%name,$did(mbuild,600).lines,600)) {
    %drw.lights = $+(%drw.lights,%name,:)
    did -a mbuild 600 %name
    write -l3 $+($scriptdir,mbuild2.mrc) $chr(37) $+ lights = %drw.lights
    load -rs $+($scriptdir,mbuild2.mrc)
  }
}
alias combo_l {
  ; cam1
  ;  _load_drop_combo colors 503

  lightcombo %drw.lights
  did -r mbuild 503
  did -o mbuild 503 1 deselect
  did -o mbuild 503 2 P_IM_Earth
  did -o mbuild 503 3 T_IM_Earth

  _load_drop_combo metals 504
  ; _load_drop_combo glass 505

  did -r mbuild 502
  did -o mbuild 502 1 Cam1
  did -o mbuild 502 2 Cam2

  did -r mbuild 505
  did -o mbuild 505 1 G_TextureA
  did -o mbuild 505 2 G_TextureB
  did -o mbuild 505 3 G_TextureC
  did -o mbuild 505 4 G_TextureD
  did -o mbuild 505 5 G_TextureE
  did -o mbuild 505 6 deselect


  did -r mbuild 506
  did -o mbuild 506 1 deselect
  did -o mbuild 506 2 fl_Oaklight
  did -o mbuild 506 3 fl_Oakdark
  did -o mbuild 506 4 fl_Merbau
  did -o mbuild 506 5 fl_Maple
  did -o mbuild 506 6 fl_Maplered
  did -o mbuild 506 7 fl_Cherry
  did -o mbuild 506 8 Floorchkr
  did -o mbuild 506 9 Floor1
  did -o mbuild 506 10 fl_chrome1c
  did -o mbuild 506 11 fl_chrome2c
  did -o mbuild 506 12 fl_chrome3c
  did -o mbuild 506 13 fl_chrome4c
  did -o mbuild 506 14 fl_chrome5c
  did -o mbuild 506 15 fl_red
  did -o mbuild 506 16 fl_blue
  did -o mbuild 506 17 fl_green


  did -r mbuild 507
  did -o mbuild 507 1 bg_png_current
  did -o mbuild 507 2 bg_water
  did -o mbuild 507 3 bg_beach2
  did -o mbuild 507 4 bg_cliffs
  did -o mbuild 507 5 bg_cliffs2
  did -o mbuild 507 6 bg_wave
  did -o mbuild 507 7 bg_fire
  did -o mbuild 507 8 deselect

  oldsky
  load_sky_combo
}
alias load_sky_combo {
  var %i = 0
  ; did -r mbuild 508
  while (%i < 130) {
    inc %i
    did -o mbuild 508 $calc(%i + 10) $pov-color(%i)
  }
}
alias oldsky {
  did -r mbuild 508
  did -o mbuild 508 1 deselect
  did -o mbuild 508 2 sky_red
  did -o mbuild 508 3 sky_yellow
  did -o mbuild 508 4 sky_green
  did -o mbuild 508 5 sky_blue
  did -o mbuild 508 6 sky_indigo
  did -o mbuild 508 7 sky_violet
  did -o mbuild 508 8 sky_peach
  did -o mbuild 508 9 sky_white
  did -o mbuild 508 10 sky_gray

}
alias _load_drop_combo {
  var %i = 0, %f = $+($scriptdir,$1,.inc), %n = $lines(%f), %id = $2
  var %r, %j = 2, %t = $1
  did -r mbuild %id
  did -o mbuild %id 1 deselect
  while (%i < %n) {
    inc %i
    %r = $read(%f,n,%i)
    if (%r) {
      ;  e %r
      tokenize 32 $gettok(%r,1,61)
      if ($1 == #declare) {
        if ((%t == metals) && (*T_* iswm $2)) { did -o mbuild %id %j $2 | inc %j }
        else if ((%t == glass) && (*Col_* iswm $2)) { did -o mbuild %id %j $2 | inc %j }
        else if ((%t == colors) && (%i > 10)) { did -o mbuild %id %j $2 | inc %j }
      }
    }
  }
}
alias _load_gdrop_combo {
  var %i = 0, %f, %n = $gpov-col(0)
  did -r mbuild 504
  while (%i < %n) {
    inc %i
    %f = $gpov-col(%i)
    did -o mbuild 504 %i %f
  }
}
alias camera_set {
  did -o mbuild 198 1 $did(mbuild,498)
  ; position
  did -o mbuild 200 1 $reversey($did(mbuild,510))
  did -o mbuild 201 1 $did(mbuild,511)
  ; size
  did -o mbuild 282 1 $did(mbuild,577)
  ; did -o mbuild 231 1 intens
  ; did -o mbuild 241 1 amb
}
alias camera_writer {
  write $1 camera $chr(123)
  write $1 location < $spcm($did(mbuild,510)) >
  write $1 look_at < $spcm($did(mbuild,498)) >
  write $1 angle $did(mbuild,511)
  write $1 $chr(125)

  if (0) {
    write -l54 $1 camera $chr(123)
    write -l55 $1 location < $spcm($did(mbuild,510)) >
    write -l56 $1 look_at < $spcm($did(mbuild,498)) >
    write -l57 $1 angle $did(mbuild,511)
    write -l58 $1 $chr(125)
  }
  if (0) {
    //location <0, 135, -300> 
    location <0, 9, -20>
    //e $angle2(0 9 -20,0 0 -1) = 24.227745317954245
    look_at <0,0,0>
    angle 67.38
  }
}
alias light_writer {
  var %i = 1, %j = 0, %n, %r
  while ($did(mbuild,600,%i)) {
    %f = $+($scriptdir,$did(mbuild,600,%i),.txt)
    %n = $lines(%f)
    %j = 0
    while (%j < %n) {
      inc %j
      %r = $read(%f,n,%j)
      if (%r) write $1 %r
    }
    inc %i
  }
}
alias spcm {
  return $replace($1-,$chr(32),$chr(44))
}
