


alias egg {
  %makefile = $$?="Make pnt & fce files?"
  ; (xyz-flat stacks slices)5
  if (($4 > 1) && ($5 > 2)) {
    spheroid2 4 $1 $2 $3 $4 $5 $rgb(200,200,255) 0 %drw.win %drw.cen.x %drw.cen.y
    echo -s $4 stacks and $5 slices has %nfaces triangles & %npts verts
  }
  else _e 2 3 min
}

alias Spheroid2 {
  %nfaces = 0
  var %f = pnt.txt
  if (%makefile) {
    %f = $+(%makefile,pnt.txt)
  }
  write -c autoface.txt
  write -c %f
  ;      $1        $2     $3    $4       $5         $6          $7    $8     $9       $10 11
  ; radius, xflat, yflat, zflat, stacks, slices, color, xrot, window, x, y

  var %eye = $calc($vlen($subv($did(mbuild,198),$did(mbuild,200))) * -1), %fol = $angle2fol($did(mbuild,201))
  drawrect -f $9 1 1 0 0 %drw.w %drw.h

  var %rho, %drho, %theta, %dtheta
  var %x, %y, %z, %s, %c, %n
  var %ctr.x = $10, %ctr.y = $11
  var %i = 0, %j = 0, %r = 0, %k = 0
  %drho = %PI / $5
  %dtheta = %PI2 / $6
  ; stacks
  var %s1 = 1, %s2 = 1, %e1 = 1, %e2 = 1
  while (%i <= $5) {
    %rho = %i * %drho
    %s = $sin(%rho)
    %c = $cos(%rho)
    %j = 0
    if ($int($calc($6 * %s)) > 1) %n = $ifmatch
    else %n = 1
    %dtheta = $calc(%PI2 / %n)
    ; e %c %s %n
    %s1 = %s2
    %s2 = %k + 1
    while (%j < %n) {
      %theta = %j * %dtheta
      ; normals
      %x = $sin(%theta) * %s
      %y = $cos(%theta) * %s
      %z = %c
      %x = $calc(%x * $1 * (1.0 - $2))
      %y = $calc(%y * $1 * (1.0 - $3))
      %z = $calc(%z * $1 * (1.0 - $4))
      %r = %x %y %z
      ; if ($8) %r = $rotxx(%x, %y, %z, $calc($8 / 57.2957795))
      if (1) {
        inc %k
        ; %pt [ $+ [ %k ] ] = %r
        ; %vertex_ [ $+ [ %k ] ] = %r
        write %f %r
      }
      ; %x = $gettok(%r,1,32) | 
      ; %y = $gettok(%r,2,32) | %z = $gettok(%r,3,32)
      ; world to screen
      %x = $int($calc(((%fol / (%eye - %z)) * %x) + %ctr.x))
      %y = $int($calc(((%fol / (%eye - %z)) * %y) + %ctr.y))
      drawdot -r $9 $7 1 %x %y
      inc %j
    }
    %e1 = %e2 
    %e2 = %k
    if ((%k > 1) && (%i <= $5)) stripfaces %s1 %e1 %s2 %e2
    inc %i
  }
  %npts = %k
  if (%makefile) {
    copy -o autoface.txt $+(%makefile,fce.txt)
    remove autoface.txt
    unset %makefile
  }
}
alias tri-equalsphere {
  drho = PI / stacks
  dtheta = PI2 / slices
  while (i <= stacks) {
    rho = i * drho
    s = $sin(rho)
    c = $cos(rho)
    j = 0
    if ($int($calc(slices * s)) > 1) n = $ifmatch
    else n = 1
    dtheta = PI2 / n
    while (j < n) {
      theta = j * dtheta
      ; normals
      x = $sin(theta) * s
      y = $cos(theta) * s
      z = c
      point = x y z
    }
  }
}
alias make-correct-faces {
  var %f = v3lofce.txt, %face, %uvv, %x, %y
  var %fc = face_indices.txt
  var %uv = uv_indices.txt
  var %u = uv_vectors.txt
  var %o = v3lopnt.obj3
  var %mat, %r, %uvw, %uvh
  var %i = 0, %j, %n = $lines(%fc), %c, %lastmat = 0
  if (0) {
    e $lines(%fc)
    e $lines(%uv)
    e $lines(%o)
    e $lines(%u)
  }
  if (01) {
    ; write -c %uv
    ; write -c %p
    write -c %f
  }

  while (%i < %n) {
    inc %i
    if ($calc(%i % 100) == 0) e %i of %n
    %r = $read(%fc,n,%i)
    %r = $remove(%r,<,>)
    %mat = $material($material2($gettok(%r,4,44)))
    tokenize 44 %r
    %face = $calc($1 + 1) $calc($2 + 1) $calc($3 + 1)
    ; e %mat
    if (%mat != %lastmat) {
      drawpic -c %drw.win 0 0 %mat
      %uvw = $pic(%mat).width
      %uvh = $pic(%mat).height
    }
    else if (!%mat) { e %mat material null at line %i | halt }
    %lastmat = %mat
    %r = $read(%uv,n,%i)
    %r = $remove(%r,<,>)
    tokenize 44 %r
    %uvv = $read(%u,n,$calc($1 + 1))
    %uvv = $remove(%uvv,<,>)
    %x = $gettok(%uvv,1,44)
    %y = $gettok(%uvv,2,44)
    %x = $int($calc(%x * %uvw))
    %y = $int($calc(%y * %uvh))
    %c = $getdot(%drw.win,%x,%y)
    if (!%c) {
      e %c color %x %y xy : LINE %i  MAT %mat %uvw %uvh %uvv
      ; halt
    }
    ; e %face %c
    write %f %face %c
  }
  e $lines(%f)
}
alias dostuf {
  var %uv = v3louv.txt
  var %p = v3lopnt.txt
  var %f = v3lofce.txt
  var %o = v3lopnt.obj
  %o = v3lopnt.obj3
  _e $lines(v3lopnt.obj2) UVs
  if (10) {
    ; write -c %uv
    ; write -c %p
    write -c %f
  }
  ; 23697 end of v
  ; 49224 end of vt == 25526
  ; 69857
  ; total = 76696
  var %r, %n = $lines(%o), %i = 0, %t, %s, %j, %nj, %mat
  e %n
  %drw.fce.file = %f
  while (%i < %n) {
    inc %i
    ; if (%i == 49225) halt
    if ($calc(%i % 100) == 0) e %i of %n
    %r = $read(%o,n,%i)
    if (%r) {
      %t = $gettok(%r,1,32)
      %r = $deltok(%r,1,32)
      ; if (%t == #) comment
      if (%t == v) {
        ; write %p %r
      }
      if (%t == vt) {
        ; UV map
        ; write %uv %r
      }
      if (%t == vn) _e 4 normal todo list
      if ((%t == f) && (10)) {
        %j = 0 | %nj = $numtok(%r,32)
        while (%j < %nj) {
          inc %j
          %s = %s $gettok($gettok(%r,%j,32),1,47)
        }
        %color = $uvdot($gettok($gettok(%r,%j,32),2,47))
        ; e %color 
        _triangulate_face %s
        ; write %f %s $uvdot($gettok($gettok(%r,%j,32),2,47))
        %s = $null
      }
      if (%t == g) {
        ; e %r
        ; group name assoc with map name
        ; could load and getdot for face color
      }
      if (%t == usemtl) {
        e %r %i
        if (10) {
          %mat = $material(%r)
          e %mat
          %uvw = $pic(%mat).width
          %uvh = $pic(%mat).height
          drawpic %drw.win 0 0 %mat
        }
      }
    }
  }
  ; _e $lines(%p) points
  ; _e $lines(%uv) UVs
  _e $lines(%f) faces
  unset %uvw %uvh %color
}
alias uvdot {
  var %uv = $read(v3lopnt.obj2,$1)
  var %x = $gettok(%uv,2,32), %y = $gettok(%uv,3,32)
  %x = $int($calc(%x * %uvw))
  %y = $int($calc(%y * %uvh))
  ; e %x %y xy
  return $getdot(%drw.win,%x,%y)
}
alias material2 {
  var %s = Nipples $&
    SkinTorso $&
    SkinHip $&
    SkinNeck $&
    SkinFeet $&
    SkinLeg $&
    Toenails $&
    SkinForearm $&
    SkinArm $&
    SkinHand $&
    Fingernails $&
    SkinHead $&
    SkinScalp $&
    Lips $&
    InnerMouth $&
    EyeSocket $&
    Nostrils $&
    Lacrimal $&
    Eyelashes $&
    Eyebrows $&
    RCornea $&
    RPupil $&
    REyewhite $&
    RIris $&
    Tongue $&
    LCornea $&
    LPupil $&
    LEyewhite $&
    LIris $&
    Teeth $&
    Gums
  return $gettok(%s,$1,32)
}
alias material {
  var %n = 2, %s = V3Lo_TeethGumsM.png V3Lo_BodyM.png $&
    V3Lo_HeadM.png V3Lo_EyeBlueM.png V3Lo_Trans.png
  ; brows & lashes = trans
  if ($1 == Teeth) %n = 1
  if ($1 == Gums) %n = 1
  if (0) {
    if ($1 == SkinTorso) %n = 2
    if ($1 == SkinFeet) %n = 2
    if ($1 == SkinHip) %n = 2
    if ($1 == SkinLeg) %n = 2
    if ($1 == Nipples) %n = 2
    if ($1 == SkinHand) %n = 2
    if ($1 == SkinForearm) %n = 2
    if ($1 == SkinArm) %n = 2
    if ($1 == Fingernails) %n = 2
    if ($1 == Toenails) %n = 2
  }
  if ($1 == SkinHead) %n = 3
  if ($1 == SkinScalp) %n = 3
  if ($1 == EyeSocket) %n = 3
  if ($1 == Nostrils) %n = 3
  if ($1 == InnerMouth) %n = 3
  if ($1 == Lips) %n = 3
  if ($1 == Lacrimal) %n = 3
  if ($1 == SkinNeck) %n = 2
  if ($1 == Tongue) %n = 3

  if ($1 == RPupil) %n = 4
  if ($1 == RIris) %n = 4
  if ($1 == RCornea) %n = 4
  if ($1 == REyewhite) %n = 4
  if ($1 == LPupil) %n = 4
  if ($1 == LIris) %n = 4
  if ($1 == LCornea) %n = 4
  if ($1 == LEyewhite) %n = 4
  if ($1 == Eyelashes) %n = 5
  if ($1 == Eyebrows) %n = 5
  ; if ($1 == ) %n = 
  return $gettok(%s,%n,32)
}
alias _loadfaces4 {
  ; (facefile, needs 2b last is a color)
  var %i = 0, %n = $lines($1), %p, %s, %c, 
  ; %pi = %drw.opntn %drw.opntn %drw.opntn
  while (%i < %n) {
    inc %i
    ; %c = $color_read($2)
    %p = $read($1,n,%i)
    ; quads must have color
    if ($gettok(%p,5,32)) {
      %c = $gettok(%p,5,32)
      %p = $gettok(%p,1-4,32)
      %s = $+(%i,:,%dr.curob,:,%c,:,%p)
    }
    else if ($gettok(%p,4,32)) {
      %c = $gettok(%p,4,32)
      %p = $gettok(%p,1-3,32)
      %s = $+(%i,:,%dr.curob,:,%c,:,%p)
    }
    ;  %p = $addvi(%p,%pi)
    inc %drw.ofcei
    %s = $+(%drw.ofcei,:,%dr.curob,:,%c,:,%p)
    %p = $dll(meshview.dll,loadfce,%s)
  }
  ; _e %p $color_read($2)
}
alias rtest {
  var %p = v3lopnt.txt
  fopen pntfile %p
  var %i = 0
  var %n = $lines(%p)
  while (%i < %n) {
    inc %i
    e $fread(pntfile)

  }
  fclose pntfile
}
alias pntfileloader {
  ; loadpntfile(0:startindex:npnts:file)
  var %p = v3lopnt.txt
  if ($1) %p = $1
  var %n = $lines(%p), %s = $+(0:1:,%n,:,%p)
  e $dll(meshview.dll,loadpntfile,%s)
}
alias fcefileloader {
  ; loadpntfile(0:startindex:nfces:file)
  var %p = v3lofce.txt
  if ($1) %p = $1
  var %n = $lines(%p), %s = $+(0:1:,%n,:,%p)
  ; e %n %s
  ; halt
  e $dll(meshview.dll,loadfcefile,%s)
}
alias loadgirl {
  _loadll
  %drw.pnt.file = v3lopnt.txt
  %drw.fce.file = v3lofce.txt
  %objname = v3lo
  did -o mbuild 32 1 %objname
  did -o mbuild 232 1 %objname

  %dr.curob = 0
  %m = % [ $+ [ $+(obj,%dr.curob,matrix) ] ]
  if (!%m) % [ $+ [ $+(obj,%dr.curob,matrix) ] ] = 1.0 0.0 0.0 0.0 1.0 0.0 0.0 0.0 1.0
  drawwin 1

  pntfileloader v3lopnt.txt
  fcefileloader v3lofce.txt
  %m = % [ $+ [ $+(obj,%dr.curob,matrix) ] ]
  %m = $gimbalmatrix(%m)
  % [ $+ [ $+(obj,%dr.curob,matrix) ] ] = %m
  ; % [ $+ [ $+(obj,%dr.curob,imatrix) ] ] = $invt(%m)
  %drw.nobjs = 1
  camerror
  _e Drawing
  ; drawnobjs
  ;   autosize
  ;   drawing
  if (0) {
    ; older code
    diacam
    camd %obj0matrix
    drawdot %drw.win
  }
}
; colors out of range 16777215 
;                                      4294967295
alias memac {
  e $dll(meshview.dll,memaccess,$1)
}
alias getpovnorms {
  write -c v3norms.inc
  dll meshview.dll smoothnorm2 70.0 1 v3norms.inc
}
alias newfaces {
  var %f = v3lofce.txt
  %f = facess.txt
  fclose faces
  fopen faces %f

  while ($fread(faces)) {
    %r = $ifmatch
    ;  tokenize 32 %r
    ; e $+(<,$calc($1 - 1),$chr(44),$calc($2 - 1),$chr(44),$calc($3 - 1),>,$chr(44))
    write newfacess.txt $left(%r,-2)
  }
  fclose faces
}

}
