alias drw_init {
  %drw.win = @MeshEdit
  drawwin
  ; /e .387 - .361 = 0.026 / 2 = 13
  ; /e .357 = 002 mill
}
alias out-elip {
  ; (pntxy, elip-centerxy, radius, radius) 0pnt is in, 1 pnt outside
  tokenize 32 $1-
  var %v = $subv2($1 $2,$3 $4)
  var %x = $gettok(%v,1,32), %y = $gettok(%v,2,32)
  if ($prop == pnt) {
    %x = $quadx($5,$6,%y)
    if ($gettok(%v,1,32) < 0) %x = %x * -1
    return $addv2i(%x %y, $3 $4)
  }
  if ($abs(%x) < $quadx($5,$6,%y)) return 0
  return 1
}
alias curve {
  ; (x,y,rw,rh,mrc-color0-15,size,$7, [degrees to rotate] )
  drwelip $1-
  ; $7 = 1-8 (which quad / fill / map) where 8 = draw all 4 quads & fill,  also %fill can be set to fill
  ; or $7 can be 8x8 BMP (full path) with which to fill
  ; 5 = all 4 quads, 6 = lower half, 7 = top half
  ; rw rh = radius width radius height
}
alias poptm2d {
  ; (v[2],m[4])
  var %x = $gettok($2,1-2,32), %y = $gettok($2,3-4,32)
  tokenize 32 $1
  %x = $multv2(%x,$1)
  %y = $multv2(%y,$2)
  return $addv2(%x,%y)
}
alias rotation2 {
  ; (radian, point[2])
  var %x, %y, %s = $sin($1), %c = $cos($1)
  tokenize 32 $2
  %x = $calc($1 * %c)
  %y = $calc($1 * %s * -1)
  inc %x $calc($2 * %s)
  inc %y $calc($2 * %c)
  return %x %y
}
alias drwelip {
  ; (x,y,rw,rh,color,size,fill=8, [degrees] ) using $out-elip().pnt
  ;  1,2,  3,  4,  5,      6,   $7(1-8),      [$8]
  var %r = $3, %b = $4, %i = 0, %c = 0, %sz = 1, %m, %7, %exists
  var %x = $1, %y = $2, %l, %l2, %l3, %l4, %p, %p2, %p3, %p4
  if ($8) {
    ; rotate xy matrix
    %m = $rotation2($deg2rad($8),1 0)
    %m = %m $rotation2($deg2rad($8),0 1)
  }
  if ($5) %c = $5
  if ($6) %sz = $6
  ; x + 1 right marker
  %l = $out-elip($calc(%x + 1), $calc(%i + %y), %x, %y, %r, %b).pnt
  ; %l2 = $out-elip($calc(%x - 1), $calc(%i + %y), %x, %y, %r, %b).pnt
  ; %l3 = $out-elip($calc(%x + 1), $calc(-1 * %i + %y), %x, %y, %r, %b).pnt
  ; %l4 = $out-elip($calc(%x - 1), $calc(-1 * %i + %y), %x, %y, %r, %b).pnt
  %l2 = %x - $gettok(%l,1,32)
  inc %l2 %x
  %l2 = %l2 $gettok(%l,2,32)
  ; %l = %x - $gettok(%l2,1,32)
  ; inc %l %x
  ; %l = %l $gettok(%l2,2,32)
  %l4 = %y - $gettok(%l2,2,32)
  inc %l4 %y
  %l4 = $gettok(%l2,1,32) %l4
  %l3 = %x - $gettok(%l4,1,32)
  inc %l3 %x
  %l3 = %l3 $gettok(%l4,2,32)
  %l = $subv2(%l, 0 1)
  %l2 = $subv2(%l2, 0 1)
  if ($8) {
    ; rotate 2d
    %l = $addv2($poptm2d($subv2(%l,$1 $2),%m),$1 $2)
    %l2 = $addv2($poptm2d($subv2(%l2,$1 $2),%m),$1 $2)
    %l3 = $addv2($poptm2d($subv2(%l3,$1 $2),%m),$1 $2)
    %l4 = $addv2($poptm2d($subv2(%l4,$1 $2),%m),$1 $2)
  }
  if ($7 isnum 1-8) %7 = $7
  else if ($exists($7)) { %7 = 8 | %exists = $7 }
  ; if $7 is an existing file we intend to fill
  while (%i < %b) {
    inc %i
    if (1) {
      %p = $out-elip($calc(%x + 1), $calc(%i + %y), %x, %y, %r, %b).pnt
      %p2 = %x - $gettok(%p,1,32)
      inc %p2 %x
      %p2 = %p2 $gettok(%p,2,32)
      %p4 = %y - $gettok(%p2,2,32)
      inc %p4 %y
      %p4 = $gettok(%p2,1,32) %p4
      %p3 = %x - $gettok(%p4,1,32)
      inc %p3 %x
      %p3 = %p3 $gettok(%p4,2,32)
      %p = $subv2(%p, 0 1)
      %p2 = $subv2(%p2, 0 1)
      if ($8) {
        %p = $addv2($poptm2d($subv2(%p,$1 $2),%m),$1 $2)
        %p2 = $addv2($poptm2d($subv2(%p2,$1 $2),%m),$1 $2)
        %p3 = $addv2($poptm2d($subv2(%p3,$1 $2),%m),$1 $2)
        %p4 = $addv2($poptm2d($subv2(%p4,$1 $2),%m),$1 $2)
      }
      ; drawdot %drw.win 0 2 %p
      ; drawdot %drw.win 0 2 %p2
      ; drawdot %drw.win 0 2 %p3
      ; drawdot %drw.win 0 2 %p4
      if (%7 == 6) {
        ; lower half
        drawline %drw.win %c %sz %p %l
        drawline %drw.win %c %sz %p2 %l2
      }
      else if (%7 == 7) {
        ; top half
        drawline %drw.win %c %sz %p3 %l3
        drawline %drw.win %c %sz %p4 %l4
      }
      else if (%7 == 1) drawline %drw.win %c %sz %p %l
      else if (%7 == 2) drawline %drw.win %c %sz %p2 %l2
      else if (%7 == 3) drawline %drw.win %c %sz %p3 %l3
      else if (%7 == 4) drawline %drw.win %c %sz %p4 %l4
      else if ((%7 == 5) || (%7 == 8)) {
        ; all 4
        drawline %drw.win %c %sz %p %l
        drawline %drw.win %c %sz %p2 %l2
        drawline %drw.win %c %sz %p3 %l3
        drawline %drw.win %c %sz %p4 %l4
      }
      %l = %p
      %l2 = %p2
      %l3 = %p3
      %l4 = %p4
    }
  }
  if (0) && (%sz == 1) {
    drawdot %drw.win %c 1 %x $calc(%y - %b)
    drawdot %drw.win %c 1 %x $calc(%y + %b)
  }
  if ((%7 == 8) || (%fill)) {
    ; fill
    if (%exists) drawfill %drw.win %c %c %x $calc(%y - 0) %exists
    else drawfill %drw.win %c %c %x $calc(%y - 0)
    unset %fill
  }
  ; drawdot %drw.win
}
alias wrtpnts {
  var %fp = %drw.pnt.file, %p, %i
  %nlprewritten = $lines(%fp)
  %i = 0
  while (%i < %pni) {
    inc %i
    %p = %pnt_ [ $+ [ %i ] ]
    write %fp $vrnd6($multv(%p,0.1))
    ; not sure of this size, maybe smaller yet
  }
  ; after all parts have been written we need a new /centerpnts that reads from *pnt.txt
  ;  timer.wrtfaces 1 2
  wrtfces $1
  %pnj = 0
  halt
}
alias wrtfces {
  ; (npoints in the circles)
  var %face, %i = 0, %j = 0, %n = %nlprewritten
  ; linear segs
  var %segs = $calc(%pni / $1 - 1)
  ; circular segs
  var %csegs = $1
  ; endcap
  %i = $1
  while (%i > 0) {
    %face = %face $calc(%i + %n)
    dec %i
  }
  _triangulate_face %face
  %i = 0
  while (%i < %segs) {
    %j = 0
    while (%j < %csegs) {
      inc %j
      if (%j < %csegs) {
        %face = $calc(%i * $1 + %j + %n) $calc(%i * $1 + %j + 1 + %n) $&
          $calc(%i * $1 + %j + 1 + %n + $1) $calc(%i * $1 + %j + %n + $1)
        _triangulate_face %face
      }
      else if (%j == %csegs) {
        ; go back to first set of - $1 for 2nd and 3rd
        %face = $calc(%i * $1 + %j + %n) $calc((%i * $1 + %j + 1 + %n) - $1) $&
          $calc(%i * $1 + %j + 1 + %n) $calc(%i * $1 + %j + %n + $1)
      }
    }
    e %i
    inc %i
  }

  %face = $null
  ; endcap
  if (01) {
    %i = 0
    ; original ; works in viewer
    while (%i < %csegs) {
      inc %i
      %face = %face $calc((%pni - %csegs) + %i + %n)
    }
  }
  else if (1) {
    %i = 0
    ; %drw.ele.file == earth.txt
    ; doesnt work in viewer
    while (%i < %csegs) {
      %face = %face $calc((%pni - %i) + %n)
      inc %i
    }
  }
  else {
    ; endcap 1 seems visible in POV but makes no sense
    %i = $1
    while (%i > 0) {
      %face = %face $calc(%i + %n)
      dec %i
    }
  }
  _triangulate_face %face
  unset %lpnt_*
  %pni = 0
}
alias add_faces {
  if (!%drw.fce.file) { _e no face file | halt }
  ; use /add_faces_init
  ; one click at a time to see if reversal is needed
  ; read those points generated (%drw.ele.file) and add perpindicular circles there at vector and put all points in mem
  ; then clk one more time to creat pnt.txt and triangulated fce.txt by editable name cause these are keepers
  ; then continue with next part of total object
  var %f = %drw.ele.file, %z = 0.0 0.0 1.0, %q, %v, %ax, %cenp, %npts = $did(mbuild,12), %p1, %p2, %i = 0, %r
  var %r, %pntisave = %pni, %point, %pointsave, %rad = %PI2 / %npts
  inc %ri
  %r = $read(%f,n,%ri)
  if (%r == endobj) {
    if ($1) %q = 1
    else %q = $?!="write pnts and fces?"
    if (%q) {
      wrtpnts %npts
    }
  }
  else {
    inc %pnj
    %cenp = $gettok(%r,1-3,32)
    %v = $gettok(%r,4-6,32)
    if ($gettok(%r,7,32)) did -o mbuild 11 1 $gettok(%r,7,32)
    %point = $multv(%v,2)
    %pointsave = %point
    %ax = $crossprod(%z,%v)
    %drw.matrix = %z %v %ax
    ; result draw counter clockwise from top
    while (%i < %npts) {
      inc %i
      inc %pni
      %pnt_ [ $+ [ %pni ] ] = $addv(%point,%cenp)
      if (%i == 1) %dotsave = $addv2i($gettok($addv(%point,%cenp),1-2,32), 0 0)
      %point = $lrotation(%rad,%ax,%point)
      if ((%pnj > 1) && (%i == 1)) {
        ; then drawline
        %p1 = %lpnt_ [ $+ [ $calc(%pni - $did(mbuild,12)) ] ]
        %p2 = %pnt_ [ $+ [ %pni ] ]
        drawline %drw.win 0 1 $addv2i($gettok(%p1,1-2,32), 0 0) $addv2i($gettok(%p2,1-2,32), 0 0)
      }
      if (%i == 1) %lpnt_ [ $+ [ %pni ] ] = $addv(%point,%cenp)
    }
    %drw.matrix = %z %v %ax
    segelipse %pntisave %cenp 1
    ; -1 or 1 reverses normals
    drawdot %drw.win 0 2 %dotsave
    unset %dotsave
    ; (pointer, 2d-linepnt, 1Left -1Right)
    ; %q = $?!="reverse axis?"
    if (%q) {
      ; do it all again reversed
      %ax = $crossprod(%v,%z)
      %point = $multv(%pointsave,-1)
      %pni = %pntisave
      %i = 0
      while (%i < %npts) {
        inc %i
        inc %pni
        %pnt_ [ $+ [ %pni ] ] = $addv(%point,%cenp)
        if (%i == 1) drawdot %drw.win 0 2 $addv2i($gettok($addv(%point,%cenp),1-2,32), 0 0)
        %point = $lrotation(%rad,%ax,%point)
        if ((%pnj > 1) && (%i == 1)) {
          ; then drawline
          %p1 = %lpnt_ [ $+ [ $calc(%pni - $did(mbuild,12)) ] ]
          %p2 = %pnt_ [ $+ [ %pni ] ]
          drawline %drw.win 0 1 $addv2i($gettok(%p1,1-2,32), 0 0) $addv2i($gettok(%p2,1-2,32), 0 0)
        }
        if (%i == 1) %lpnt_ [ $+ [ %pni ] ] = %pnt_ [ $+ [ %pni ] ]
      }
      %drw.matrix = %z %v %ax
      segelipse %pntisave %cenp -1
    }
  }
}
; left CCW, for direction 1
; 1 | 4
; ------
; 2 | 3
; right CW, for direction -1
; 2 | 1
; ------
; 3 | 4
alias quadelip {
  ; quadelip 1 180 100 30 1 0
  ; (quad, w, h, npnts per quad, direction 1 or -1, last-pointer-used)
  ; first set %drw.cenp %drw.matrix
  var %j = 0, %point, %circlep
  var %i = 0, %rad = $calc(%PI.5 / $4 * $5)
  var %cenp = %drw.cen.x %drw.cen.y 0.0, %ax = 0.0 0.0 1.0
  var %m = 0.0 1.0 0.0 1.0 0.0 0.0 0.0 0.0 1.0, %v
  if ($1 == 1) %v = 0.0 -1.0 0.0
  if ($1 == 2) %v = -1.0 0.0 0.0
  if ($1 == 3) %v = 0.0 1.0 0.0
  if ($1 == 4) %v = 1.0 0.0 0.0
  %point = $multv(%v,$3)
  %circlep = $multv(%v,$2)
  %cenp = %drw.cenp
  %m = %drw.matrix
  %j = $6
  while (%i < $4) {
    inc %i
    inc %j
    if ($gettok(%circlep,2,32) > 0.0) $&
      %point = $gettok(%circlep,1,32) $quady($2,$3, $gettok(%circlep,1,32)) 0.0
    else %point = $gettok(%circlep,1,32) $calc(-1 * $quady($2,$3,$gettok(%circlep,1,32))) 0.0

    %point = $poptmatrix(%point,%m)
    ; drawdot %drw.win 0 2 $addvi(%circlep,%cenp)
    drawdot %drw.win 9 2 $addvi(%point,%cenp)

    %pnt_ [ $+ [ %j ] ] = $vrnd6($addv(%point,%cenp))
    %circlep = $lrotation(%rad,%ax,%circlep)
  }
}
alias quadincx {
  ; quadincx 1 180 100 30 1 xlen, last-pointer-used, add/flatten curve
  ; (quad, w, h, npnts per quad, direction 1 or -1, xlen)
  ; first set %drw.cenp %drw.matrix
  var %j = 0, %point, %circlep
  var %i = 0, %rad = $calc(%PI.5 / $4 * $5)
  var %rad2 = $calc(%PI / $4)
  var %point2 = $multv(-1.0 0.0 0.0,$abs($8))

  var %cenp = %drw.cen.x %drw.cen.y 0.0, %ax = 0.0 0.0 1.0
  var %m = 0.0 1.0 0.0 1.0 0.0 0.0 0.0 0.0 1.0, %v
  if ($1 == 1) %v = 0.0 -1.0 0.0
  if ($1 == 2) %v = -1.0 0.0 0.0
  if ($1 == 3) %v = 0.0 1.0 0.0
  if ($1 == 4) %v = 1.0 0.0 0.0
  %point = $multv(%v,$3)
  %circlep = $multv(%v,$2)
  %cenp = %drw.cenp
  %m = %drw.matrix
  var %x = $doubletcast(0), %l
  if ($5 == -1) {
    if (($1 == 2) || ($1 == 3)) %x = $calc($2 * -1)
    if (($1 == 1) || ($1 == 4)) %x = $2
  }
  %j = $7
  while (%i < $4) {
    inc %i
    inc %j
    if ($gettok(%circlep,2,32) > 0.0) $&
      %point = %x $quady($2,$3, %x) 0.0
    else %point = %x $calc(-1 * $quady($2,$3,%x)) 0.0

    ; add curve
    %l = $calc($vlen(%point) + $gettok(%point2,2,32))
    if ($8 < 0) %l = $calc($vlen(%point) - $gettok(%point2,2,32))
    %point = $multv($normalize(%point),%l)

    %point = $poptmatrix(%point,%m)
    ; drawdot %drw.win 0 2 $addvi(%circlep,%cenp)
    drawdot %drw.win 9 2 $addvi(%point,%cenp)

    %pnt_ [ $+ [ %j ] ] = $vrnd6($addv(%point,%cenp))
    %circlep = $lrotation(%rad,%ax,%circlep)
    %point2 = $lrotation(%rad2,%ax,%point2) 
    ; e $gettok(%point2,2,32)
    if ($5 == 1) {
      ; left
      if (($1 == 1) || ($1 == 3)) %x = $calc(%x + $6)
      if (($1 == 2) || ($1 == 4)) %x = $calc(%x - $6)
    }
    if ($5 == -1) {
      ; left
      if (($1 == 2) || ($1 == 3)) %x = $calc(%x + $6)
      if (($1 == 1) || ($1 == 4)) %x = $calc(%x - $6)
    }
  }
}
alias segelipse {
  ; (pointer, 3d-linepnt, 1Left -1Right)
  var %j = 0, %example = 0
  if ($1) %j = $1
  var %i = 0, %rad = $calc(%PI2 / $did(mbuild,12) * $5)
  ; if ($6) %rad = $calc(%PI2 / $did(mbuild,12) * $6)
  var %point = $multv(0.0 -1.0 0.0,$did(mbuild,11))
  var %circlep = $multv(0.0 -1.0 0.0,$did(mbuild,10))
  var %cenp = %drw.cen.x %drw.cen.y 0.0, %ax = 0.0 0.0 1.0
  var %m = %drw.matrix 
  if (%example) %m = 0.0 1.0 0.0 1.0 0.0 0.0 0.0 0.0 1.0
  ; %m = 1.0 0.0 0.0 0.0 1.0 0.0 0.0 0.0 1.0
  ; %m = $invt(%m)
  if (%example) unset %string %string2
  while (%i < $did(mbuild,12)) {
    inc %i
    inc %j
    if (%example) %string = %string $vrnd4(%circlep)
    %point = $poptmatrix(%point,%m)
    if (%example) %string2 = %string2 $vrnd4(%point)
    else %pnt_ [ $+ [ %j ] ] = $vrnd6($addv(%point,$gettok($1-,2-4,32)))
    %circlep = $lrotation(%rad,%ax,%circlep)
    if ($gettok(%circlep,2,32) > 0.0) $&
      %point = $gettok(%circlep,1,32) $quady($did(mbuild,10),$did(mbuild,11), $gettok(%circlep,1,32)) 0.0
    else %point = $gettok(%circlep,1,32) $calc(-1 * $quady($did(mbuild,10),$did(mbuild,11),$gettok(%circlep,1,32))) 0.0
  }
  if (%example) {
    timer.segex -m $did(mbuild,12) 40 drawthis
    %stri = 0
  }
}
alias drawthis {
  var %circlep, %point
  var %cenp = %drw.cen.x %drw.cen.y
  inc %stri
  %circlep = $gettok(%string,$calc(%stri * 3 - 2) - $calc(%stri * 3),32)
  drawdot %drw.win 0 2 $addv2i($gettok($addv(%circlep,%cenp),1-2,32), 0 0)
  %point = $gettok(%string2,$calc(%stri * 3 - 2) - $calc(%stri * 3),32)
  drawdot %drw.win 13 2 $addv2i($gettok($addv(%point,%cenp),1-2,32), 0 0)
  if (%lc) drawline %drw.win 0 1 %lc $addv2i($gettok($addv(%circlep,%cenp),1-2,32), 0 0)
  if (%lp) drawline %drw.win 13 1 %lp $addv2i($gettok($addv(%point,%cenp),1-2,32), 0 0)
  %lp = $addv2i($gettok($addv(%point,%cenp),1-2,32), 0 0)
  %lc = $addv2i($gettok($addv(%circlep,%cenp),1-2,32), 0 0)
  ; e %point
}
alias click_capture {
  ; use click_capture_init
  ; shift click center of radius
  ; then clk on 2d image pnt and src vevtor
  var %pnt = $doubletcast($mouse.x,$mouse.y,0)
  var %f = %drw.ele.file
  ; store radius src
  if ($mouse.key & 4) %rad.src = %pnt
  else if ($mouse.key & 2) { 
    write %f endobj
    e endobj
  }
  else {
    if (%rad.src) _e %pnt $vrnd6($normalize($subv(%pnt,%rad.src))))
    else _e %pnt
    if (%rad.src) write %f %pnt $vrnd6($normalize($subv(%pnt,%rad.src))))
    else write %f %pnt
    drawdot %drw.win 13 2 $addv2i($gettok(%pnt,1-2,32),0 0)
    unset %rad.src
  }
}
alias doubletcast {
  if ($chr(44) isin $1) tokenize 44 $1
  else tokenize 32 $1-
  var %i = 0, %s, %n
  while (%i < $0) {
    inc %i
    %n = $gettok($1-,%i,32)
    if (. !isin %n) %n = %n $+ .0
    %s = %s %n
  }
  return %s
}
alias vrnd6 {
  tokenize 32 $1-
  var %i = 0, %s, %n
  while (%i < $0) {
    inc %i
    %n = $gettok($1-,%i,32)
    %n = $lround(%n,6)
    %s = %s %n
  }
  return %s
}
alias _triangulate_face {
  var %f = %drw.fce.file
  ; var %f2 = %drw.fce.file2
  var %n = $0, %i = 0, %s = $1-
  dec %n 2
  while (%i < %n) {
    inc %i
    ; write %f2 $gettok(%s,3,32) $gettok(%s,2,32) $gettok(%s,1,32)
    ; if ($lines(%drw.fce.file) < 2500)
    write %f $gettok(%s,1,32) $gettok(%s,2,32) $gettok(%s,3,32) %color
    ; else
    ; write %f2 $gettok(%s,1,32) $gettok(%s,2,32) $gettok(%s,3,32)
    %s = %s $gettok(%s,1,32)
    %s = $deltok(%s,1-2,32)
  }
}
alias centerpoint {
  ; plus translation to center //e $centerpoint(0).transl
  var %i = 0, %p, %v, %xl = -50000, %yl = -50000, %zl = -50000
  var %x = 50000, %y = 50000, %z = 50000
  var %n = $lines(%drw.pnt.file)
  while (%i < %n) {
    inc %i
    %p = $read(%drw.pnt.file,n,%i)
    tokenize 32 %p
    if ($1 < %x) %x = $1
    if ($1  > %xl) %xl = $1
    if ($2 < %y) %y = $2
    if ($2  > %yl) %yl = $2
    if ($3 < %z) %z = $3
    if ($3  > %zl) %zl = $3
  }
  %v = $divv($subv(%xl %yl %zl,%x %y %z),2)
  %v = $vrnd6($addv(%v,%x %y %z))
  ; if loaded at size and drawn at size then size/2, but / 3 has me ?, -needs reversal, viewer trans adds v
  if ($prop == transl) return $vrnd4($multv(%v,$calc($did(mbuild,282) / 2 / -3.3333333)))
  return %v
}
alias centerpntxt {
  ;  var %i = 0, %p, %v, %xl = 0, %yl = 0, %zl = 0
  var %i = 0, %p, %v, %xl = -50000, %yl = -50000, %zl = -50000
  var %x = 50000, %y = 50000, %z = 50000
  var %n = $lines(%drw.pnt.file)
  var %bf = $left(%drw.pnt.file,-7)
  if (!%bf) %bf = offuntitled.txt
  else %bf = $+(offbk,%bf,.txt)
  copy -o $+($mircdir,%drw.pnt.file) $+($mircdir,%bf)
  if ($lines(%bf) == %n) write -c %drw.pnt.file
  else { _e error copying %drw.pnt.file | halt }
  while (%i < %n) {
    inc %i
    %p = $read(%bf,n,%i)
    tokenize 32 %p
    if ($1 < %x) %x = $1
    if ($1  > %xl) %xl = $1
    if ($2 < %y) %y = $2
    if ($2  > %yl) %yl = $2
    if ($3 < %z) %z = $3
    if ($3  > %zl) %zl = $3
  }
  %v = $divv($subv(%xl %yl %zl,%x %y %z),2)
  %v = $addv(%v,%x %y %z)
  %i = 0
  while (%i < %n) {
    inc %i
    %p = $read(%bf,n,%i)
    %p = $subv(%p,%v)
    ; scale up
    ; %p = $multv(%p,%drw.scale)
    write %drw.pnt.file $vrnd6($multv(%p,1.0))
  }

  e $lines(%bf) Old Point File at %bf
  e $lines(%drw.pnt.file) Points in new file
  e $lines(%drw.fce.file) Faces
  %clk.cap = 0
  did -u mbuild 22
}
alias centerpnts {
  ; (n pnts)
  var %i = 0, %p, %v, %xl = -50000, %yl = -50000, %zl = -50000
  var %x = 50000, %y = 50000, %z = 50000
  var %n = $1
  while (%i < %n) {
    inc %i
    %p = %pnt_ [ $+ [ %i ] ]
    tokenize 32 %p
    if ($1 < %x) %x = $1
    if ($1  > %xl) %xl = $1
    if ($2 < %y) %y = $2
    if ($2  > %yl) %yl = $2
    if ($3 < %z) %z = $3
    if ($3  > %zl) %zl = $3
  }
  %v = $divv($subv(%xl %yl %zl,%x %y %z),2)
  %v = $addv(%v,%x %y %z)
  %i = 0
  while (%i < %n) {
    inc %i
    %p = %pnt_ [ $+ [ %i ] ]
    %p = $subv(%p,%v)
    ; scale
    ; %p = $multv(%p,2.6)
    ; %pnt_ [ $+ [ %i ] ] = %p
    %p = $addv(%p,%v)
    e $vrnd6($multv(%p,1.0))
  }
}
alias segelipsz {
  ; (p1,p2,p3).endcap & (p1,p2,v).h
  var %w = $did(mbuild,10), %h, %a
  var %z = 0.0 0.0 1.0, %v, %endcap, %r
  if ($prop == h) {
    %a = $radian($2,$1,$multv($3,-1))
    if (%a >= %PI.5) %a = $radian($2,$1,$3))
    %a = %PI.5 - %a
    %h = $asa-sin(%a,%w,%PI.5)
    return $round(%h,3)
  }
  if ($3 != $null) %r = $calc($radian($2,$1,$3) / 2)
  if ($prop == endcap) {
    %v = $normalize($subv($1,$2))
    %endcap = $crossprod(%v,%z)
    return $1 $vrnd6(%endcap) %w
  }
  else if ($prop == endcap2) {
    %v = $normalize($subv($1,$2))
    %endcap = $crossprod(%v,%z)
    return $2 $vrnd6(%endcap) %w
  }
  else if ($bendingrt($1,$2,$3)) {
    ; opposite angle bends right
    %v = $lrotation(%r, 0.0 0.0 1.0,$subv($1,$2))
  }
  else if (10) %v = $lrotation(%r, 0.0 0.0 1.0,$subv($2,$3))
  else {
    %v = $midpoint($multv($normalize($subv(%p2,%p)),500), $&
      $multv($normalize($subv(%p2,%p3)),500))
  }
  ; solve opposing side of angle2 = elipse height
  %a = %PI.5 - %r
  %h = $asa-sin(%a,%w,%PI.5)
  return $2 $vrnd6($normalize(%v)) $round(%h,3)
}
alias segangles {
  ; [start read line #]
  var %n = $countsegs, %i = $gettok(%n,1,32), %w = $did(mbuild,10), %h, %a
  %n = $gettok(%n,2,32)
  var %p2 = 201.0 240.0 0.0,%p = 302.0 240.0 0.0, %p3 = 210.0 270.0 0.0
  var %r, %z = 0.0 0.0 1.0, %v, %endcap, %endcap2, %j = 1
  if ($1) %i = $1
  while (%j < $calc(%n - 1)) {
    %p = $read(%drw.ele.file,%i)
    %p2 = $read(%drw.ele.file,$calc(%i + 1))
    %p3 = $read(%drw.ele.file,$calc(%i + 2))
    if (%j == 1) {
      tokenize 32 %p
      if ($4 == $null) {
        e $segelipsz($gettok(%p,1-3,32),$gettok(%p2,1-3,32)).endcap
      }
    }
    tokenize 32 %p2
    if ($4 == $null) {
      %p = $gettok(%p,1-3,32)
      %p2 = $gettok(%p2,1-3,32)
      %p3 = $gettok(%p3,1-3,32)
      e $segelipsz(%p,%p2,%p3)
    }
    inc %j
    inc %i
  }
  %p = $read(%drw.ele.file,%i)
  %p2 = $read(%drw.ele.file,$calc(%i + 1))
  tokenize 32 %p2
  if ($4 == $null) {
    e $segelipsz($gettok(%p,1-3,32),$gettok(%p2,1-3,32)).endcap2
  }
}
alias countsegs {
  var %n = $lines(%drw.ele.file), %r = 1, %i
  dec %n
  %i = %n
  while ((%r) && (%r != endobj)) {
    %r = $read(%drw.ele.file,%i)
    if ((%r) && (%r != endobj)) dec %i
  }
  return $calc(%i + 1) $calc(%n - %i)
  first line and n
}
alias testt {
  e $bendingrt_(311.0 220.0 0.0,207.0 220.0 0.0,219.0 207.0 0.0)
  e $bendingrt_(207.0 220.0 0.0,219.0 207.0 0.0,235.0 188.0 0.0)
}
alias bendingrt {
  var %a = $subv($1,$2), %b = $subv($3,$2)
  if ($gettok($crossprod(%a,%b),3,32) < 0) return 1
  return 0
}
alias bendingrt-yuk {
  var %a = $vrnd6($normalize($subv($1,$2))), %b = $vrnd6($normalize($subv($3,$2)))
  if ($gettok($crossprod(%a,%b),3,32) < 0) return 1
  return 0
}
alias bendingrt_ {
  ; (where z is of no interest, and 4th parm of axis must remain the same)
  var %r = $radian($2,$1,$3)
  var %1 = $vrnd6($normalize($subv($1,$2))), %3 = $vrnd6($normalize($subv($3,$2)))
  var %axis 0.0 0.0 1.0
  if ($4) %axis = $4
  ; %axis = $normalize($crossprod(%1,%3)))
  ; e %axis
  var %p = $lrotation(%r,%axis,%1)
  %p = $vrnd6(%p)
  if ($vporm(%p,%3,0.000001)) return 1
  %r = %r * -1
  %p = $lrotation(%r,%axis,%1)
  %p = $vrnd6(%p)
  if ($vporm(%p,%3,0.000001)) return 0
  e %p == %3 fzl
  return 0
  return fuzzylogic
}
alias vporm {
  ; (rotated pnt, compare pnt, tolerance)
  ; vector plus or minus
  if ($1 == $2) return 1
  tokenize 32 $1-
  var %a = $4 - $7, %b = $5 - $7
  if (($1 == %a) && ($2 == %b)) return 1
  if (($1 == %a) && ($2 == $5)) return 1
  if (($1 == $4) && ($2 == %b)) return 1
  %a = $4 + $7 | %b = $5 + $7
  if (($1 == %a) && ($2 == %b)) return 1
  if (($1 == %a) && ($2 == $5)) return 1
  if (($1 == $4) && ($2 == %b)) return 1
  %a = $4 + $7 | %b = $5 - $7
  if (($1 == %a) && ($2 == %b)) return 1
  if (($1 == %a) && ($2 == $5)) return 1
  if (($1 == $4) && ($2 == %b)) return 1
  %a = $4 - $7 | %b = $5 + $7
  if (($1 == %a) && ($2 == %b)) return 1
  if (($1 == %a) && ($2 == $5)) return 1
  if (($1 == $4) && ($2 == %b)) return 1
  return 0
}
alias vrnd4 {
  tokenize 32 $1-
  var %i = 0, %s, %n
  while (%i < $0) {
    inc %i
    %n = $gettok($1-,%i,32)
    %n = $lround(%n,4)
    %s = %s %n
  }
  return %s
}
menu @MeshEdit {
  sclick: {
    if (%clk.cap == 1) click_capture
    else if (%clk.cap == 2) add_faces
    else if (%clk.cap == 4) getcolor
    else if (%drw.edmode > 1) predinit
    else if (%drw.edmode == 1) add_clk_pnts
    ;      else if (%clk.cap > 4) {  }
  }
  uclick: dragu
  mouse: {
    if (%clk.cap > 4) {
      drawrect -fn %drw.win 1 1 0 0 60 20
      drawtext -n %drw.win 0 arial 14 0 0 $mouse.x $mouse.y
      dragpoint
      drawdot %drw.win
    }
  }
}
alias click_capture_init {
  var %f = $did(mbuild,32)
  ; if (!%f) %f = %objname 
  if (!%f) { _e We got no name = halting | halt }
  else {
    did -o mbuild 32 1 %f
    %objname = %f
    %drw.ele.file = $+(%f,.txt)
    %drw.pnt.file = $+(%f,pnt.txt)
    %drw.fce.file = $+(%f,fce.txt)
  }
  %pnj = 0
  %pni = 0
  %ri = 0
  unset %pnt_*
  unset %lpnt_*
  set %drw.h $window(%drw.win).h
  set %drw.w $window(%drw.win).w
  %clk.cap = 1
}
alias add_faces_init {
  set %drw.h $window(%drw.win).h
  set %drw.w $window(%drw.win).w
  %clk.cap = 2
  %pnj = 0
  %pni = 0
  %ri = 0
  unset %pnt_*
  unset %lpnt_*
  var %f = $did(mbuild,32)
  if (!%f) { _e We got no name = halting | halt }
  else {
    did -o mbuild 32 1 %f
    %objname = %f
    %drw.ele.file = $+(%f,.txt)
    %drw.pnt.file = $+(%f,pnt.txt)
    %drw.fce.file = $+(%f,fce.txt)
    ; %drw.fce.file2 = $+(%f,fce2.txt)
  }
  ;  //echo $?!="Shall I continue?"
  var %q = $?!="Overwrite %drw.pnt.file & %drw.fce.file ?"
  if (!%q) { _e halting | halt }
  write -c %drw.pnt.file
  write -c %drw.fce.file
  ; %drw.fce.file2 = $+($left(%drw.fce.file,-4),2.txt)
}
alias clkstart {
  ; add_faces_init
  drw_init
  ; element draw command
  if (($did(mbuild,32) == fire) || ($did(mbuild,32) == water)) fire
  else ele-earth
  ; ele-earth
  click_capture_init
  ; end each part of obj with ctrl clk
}
alias faces {
  var %i = 0
  while (%i < 75) {
    inc %i
    add_faces 1
  }
}
alias commands {
  ; click_capture_init
  add_faces_init
  drawrect -f %drw.win 1 1 0 0 %drw.w %drw.h
  if (($did(mbuild,32) == fire) || ($did(mbuild,32) == water)) fire
  else ele-earth
  ; /faces
  ; /centerpntxt
  ; = /commandline enter
}
alias addsegdata {
  var %f = $+($mircdir,bk,%drw.ele.file)
  copy -o %drw.ele.file %f
  var %i = 0, %j = 0, %n = $lines(%drw.ele.file), %r, %p, %p2 , %p3
  if ($lines(%f) == %n)  write -c %drw.ele.file
  else { _e error copying %drw.ele.file halting | halt }
  while (%i < %n) {
    inc %i
    inc %j
    %p = $read(%f,%i)
    %p2 = $read(%f,$calc(%i + 1))
    %p3 = $read(%f,$calc(%i + 2))
    if (%j == 1) {
      tokenize 32 %p
      if ($4 == $null) {
        write %drw.ele.file $segelipsz($gettok(%p,1-3,32),$gettok(%p2,1-3,32)).endcap
      }
      else {
        if ($7) write %drw.ele.file %p
        else write %drw.ele.file $gettok(%p,1-6,32) $segelipsz($gettok(%p,1-3,32),$gettok(%p2,1-3,32),$gettok(%p,4-6,32)).h
      }
    }
    if (%p3 != endobj) {
      tokenize 32 %p2
      if ($4 == $null) {
        ; %p = $gettok(%p,1-3,32)
        ; %p2 = $gettok(%p2,1-3,32)
        ; %p3 = $gettok(%p3,1-3,32)
        write %drw.ele.file $segelipsz($gettok(%p,1-3,32),$gettok(%p2,1-3,32),$gettok(%p3,1-3,32))
      }
      else {
        if ($7) write %drw.ele.file %p2
        else write %drw.ele.file $gettok(%p2,1-6,32) $segelipsz($gettok(%p,1-3,32),$gettok(%p2,1-3,32),$gettok(%p2,4-6,32)).h
      }
    }
    if (%p3 == endobj) {
      %j = 0
      inc %i 2
      tokenize 32 %p2
      if ($4 == $null) {
        write %drw.ele.file $segelipsz($gettok(%p,1-3,32),$gettok(%p2,1-3,32)).endcap2
        write %drw.ele.file endobj
      }
      else {
        if ($7) write %drw.ele.file %p2
        else write %drw.ele.file $gettok(%p2,1-6,32) $segelipsz($gettok(%p,1-3,32),$gettok(%p2,1-3,32),$gettok(%p2,4-6,32)).h
        write %drw.ele.file endobj
      }
    }
  }
  _e $lines(%drw.ele.file)
  _e $lines(%f)
}
alias dup {
  var %f = fix.txt, %n = $lines(%f)
  var %i = 0, %r
  e %i $n
  while (%i < %n) {
    inc %i
    %r = $read(%f,%i)
    ; %r = $gettok(%r,1-3,32)
    ;  e $vrnd6($addv(%r,0.0 0.0 4.0))
    e $vrnd6($addv($gettok(%r,1-3,32),0.0 0.0 4.0)) $gettok(%r,4-,32)
  }
}
alias bkdup {
  var %f = %drw.ele.file
  var %i = 0, %r, %n = $lines(%drw.ele.file)
  while (%i < %n) {
    inc %i
    %r = $read(%f,%i)
    %r = $gettok(%r,1-3,32)
    ; e $vrnd6($addv(%r,54.0 0.0 0.0))
    write bkwater.txt %r
  }
}

alias rbkdup {
  var %f = dup.txt
  var %i = 0, %r, %n = $lines(%f)
  ; %i = %n
  while (%i < 8) {
    inc %i
    %r = $read(%f,%i)
    ;    %r = $gettok(%r,1-3,32)
    e $vrnd6($addv($gettok(%r,1-3,32),62.0 0.0 0.0)) $gettok(%r,4-,32)
    ; write bkwater.txt %r
  }
}


alias second file {
  max pnts = 2200
  max fces = 4000
  fire = 
  Object 0 with 696 Points Loaded
  Object 0 with 1262 Faces Loaded
  *****************
  water
  Object 0 with 1440 Points Loaded
  Object 0 with 2628 Faces Loaded

  Object 0 with 1560 Points Loaded
  Object 0 with 2848 Faces Loaded
  *****************
  earth
  Object 0 with 996 Points Loaded
  Object 0 with 1812 Faces Loaded
  air
  Object 0 with 1188 Points Loaded
  Object 0 with 2174 Faces Loaded
}
