// meshview.cpp : Defines the initialization routines for the DLL.
//

#include "stdafx.h"
#include "meshview.h"
#include <windows.h>
#include <string.h>
#include <math.h>
#include <time.h>
#include <stdlib.h>


double _quadx(double r, double h, double y);
double _quady(double r, double h, double x);
int invertmatrix(double mat[16], double inv[16]);
double rround(double a, int b);
void rotate(double sc[2], double axis[3], double point[3]);
void rotation(double angle, double axis[3], double point[3]);
double radang3(double v[3], double v2[3], double v3[3]);
double radang(double v[3], double v2[3]);

// count only existing tokens, ignore multi spacers
void _gettok(char *d, int t, int sep);
int _numtok(char *d, int sep);
void _deltok(char *d, int t, int sep);
// count separators
void gettokk(char *d, int t, int sep);
int numtokk(char *d, int sep);
void deltok(char *d, int t, int sep);

// strtok
int numtok(char *d, int sep);
char *gettok(char *d, int t, int sep);

int getdot(HWND mWnd, char *win,int i,int j);

void sendmirc(HWND hwnd, char *data);
void evalmirc(HWND hwnd, char *data);
void incenter(int p1[2],int p2[2],int p3[2]);
int numrend = 0;

typedef struct {
	int id;
	int labelc;
	int x;
	int y;
	double z;
} renddata;
renddata rendlist[160];

#define COPYV( A, B )					\
do {													\
   (A)[0] = (B)[0];						\
   (A)[1] = (B)[1];						\
   (A)[2] = (B)[2];						\
} while (0)
#define ADDV(A, B, C)					\
do {													\
	(A)[0] = (B)[0] + (C)[0];		\
	(A)[1] = (B)[1] + (C)[1];		\
	(A)[2] = (B)[2] + (C)[2];		\
} while (0)
#define SUBV(A, B, C)					\
do {						\
	(A)[0] = (B)[0] - (C)[0];		\
	(A)[1] = (B)[1] - (C)[1];		\
	(A)[2] = (B)[2] - (C)[2];		\
} while (0)
#define MULTV(A, B, C)				\
do {						\
	(A)[0] = (B)[0] * (C);			\
	(A)[1] = (B)[1] * (C);			\
	(A)[2] = (B)[2] * (C);			\
} while (0)
#define DIVV(A, B, C)					\
do {							\
	(A)[0] = (B)[0] / (C);			\
	(A)[1] = (B)[1] / (C);			\
	(A)[2] = (B)[2] / (C);			\
} while (0)
#define INITV( A, x, y, z)             \
do {																				\
   (A)[0] = (x);                            \
   (A)[1] = (y);                            \
   (A)[2] = (z);                            \
} while (0)

#define DOTPRODUCT(A, B) ((A)[0]*(B)[0] + (A)[1]*(B)[1] + (A)[2]*(B)[2])
#define CROSSPRODUCT(A, B, C)							\
do {																			\
 (A)[0] = (B)[1]*(C)[2] - (B)[2]*(C)[1];	\
 (A)[1] = (B)[2]*(C)[0] - (B)[0]*(C)[2];	\
 (A)[2] = (B)[0]*(C)[1] - (B)[1]*(C)[0];	\
} while (0)
#define NORMALIZE(V)							\
do {															\
	double d=VLEN(V);							\
	if (!d) d = 1;										\
	(V)[0]/=d;												\
	(V)[1]/=d;												\
	(V)[2]/=d;												\
} while (0)
#define REVY(V)							\
do {															\
	(V)[1]*=-1;												\
} while (0)
#define NORMALVECTOR(A, B, C, D)	\
do {															\
		double E[3], F[3];						\
		SUBV(E,C,B);									\
		SUBV(F,D,B);									\
		CROSSPRODUCT(A, E, F);				\
} while(0)

#define MIDPOINT(A, B, C)						\
	do {															\
	(A)[0] = ((B)[0] + (C)[0]) / 2;		\
	(A)[1] = ((B)[1] + (C)[1]) / 2;		\
	(A)[2] = ((B)[2] + (C)[2]) / 2;		\
}while(0)

#define DEG2RAD(x) ((x)/57.29577951308238)
#define RAD2DEG(x) ((x)*57.29577951308238)
#define LENGTH(x,y,z) sqrt(x*x+y*y+z*z)
#define VLEN2(v) sqrt(v[0]*v[0]+v[1]*v[1])

#define SUBV2(A, B, C)					\
do {						\
	(A)[0] = (B)[0] - (C)[0];		\
	(A)[1] = (B)[1] - (C)[1];		\
} while (0)

#define VLEN(v) sqrt(v[0]*v[0]+v[1]*v[1]+v[2]*v[2])
#define PI 3.14159265358979323846264338
#define CLAMP( X, MIN, MAX )  ( (X)<(MIN) ? (MIN) : ((X)>(MAX) ? (MAX) : (X)) )
#define WM_MCOMMAND (WM_USER + 200)
#define WM_MEVALUATE (WM_USER + 201)



HMODULE dll;
#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

//
//	Note!
//
//		If this DLL is dynamically linked against the MFC
//		DLLs, any functions exported from this DLL which
//		call into MFC must have the AFX_MANAGE_STATE macro
//		added at the very beginning of the function.
//
//		For example:
//
//		extern "C" BOOL PASCAL EXPORT ExportedFunction()
//		{
//			AFX_MANAGE_STATE(AfxGetStaticModuleState());
//			// normal function body here
//		}
//
//		It is very important that this macro appear in each
//		function, prior to any calls into MFC.  This means that
//		it must appear as the first statement within the 
//		function, even before any object variable declarations
//		as their constructors may generate calls into the MFC
//		DLL.
//
//		Please see MFC Technical Notes 33 and 58 for additional
//		details.
//

/////////////////////////////////////////////////////////////////////////////
// CMeshviewApp

BEGIN_MESSAGE_MAP(CMeshviewApp, CWinApp)
	//{{AFX_MSG_MAP(CMeshviewApp)
		// NOTE - the ClassWizard will add and remove mapping macros here.
		//    DO NOT EDIT what you see in these blocks of generated code!
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMeshviewApp construction

CMeshviewApp::CMeshviewApp()
{
	// TODO: add construction code here,
	// Place all significant initialization in InitInstance
}
// 3200 6000
typedef struct {
	char name[20];
	double pnt[25000][3];
	double matp[25000][3];

	double normal[50000][3];
	int fce[50000][3]; // face indicies
	int fcecol[50000]; // faceolor
	
	//double size;
	int nfces;
	int npnts;
} objdata;
objdata object[1];
int __stdcall loadpnt(
		HWND mWnd,
		HWND aWnd,
		char *data,
		char *parms,
		BOOL print,
		BOOL nopause) {
	// 1 = first pnt. [0] can be a centroid
	// can recall with more points, start at pnt-one resets npnts 
	// (startindex:obj:reserved:str-vectors[3]32:[multi pnts])

	char s[99];
	int n = numtok(data,58) - 3;
	// n cannot be less than 1
	int i = atoi(data);
	int obj = atoi(gettok(data,2,58));
	object[obj].pnt[0][0] = 0.0;
	object[obj].pnt[0][1] = 0.0;
	object[obj].pnt[0][2] = 0.0;
	if (i == 1) object[obj].npnts = 0;
	for (int j = 1;j<=n;j++) {
		sprintf(s,gettok(data,j+3,58));
		object[obj].pnt[i][0] = atof(s);
		object[obj].pnt[i][1] = atof(gettok(s,2,32));
		object[obj].pnt[i][2] = atof(gettok(s,3,32));
		i++;
	}
	object[obj].npnts += n;
	sprintf(data,"Object %i with %i Points Loaded",obj,object[obj].npnts);
	return 3;
}
int __stdcall loadpntfile(
		HWND mWnd,
		HWND aWnd,
		char *data,
		char *parms,
		BOOL print,
		BOOL nopause) {
	// 1 = first pnt. [0] can be a centroid
	// can recall with more points, start at pnt-one resets npnts 
	// loadpntfile(0:startindex:npnts:file)

	char s[99], d[900];
	int obj = atoi(data);
	int i = atoi(gettok(data,2,58));
	int k = 0, l = 2, n = atoi(gettok(data,3,58));

	sprintf(s,gettok(data,4,58));
	sprintf(data,"/fopen pntfile %s",s);
	sendmirc(mWnd,data);
	if (i == 1) {
		object[obj].pnt[0][0] = 0.0;
		object[obj].pnt[0][1] = 0.0;
		object[obj].pnt[0][2] = 0.0;
		object[obj].npnts = 0;
	}
	for (int j = 1;j<=n;j++) {
		sprintf(data,"$fread(pntfile)");
		evalmirc(mWnd,data);
		
		if (_numtok(data,32) == 3) l = 1;
		else l = 2;
		for (k = 0;k<3;k++) {
			sprintf(d,data);
			_gettok(d,l,32);
			// double spaced in file, handle

			object[obj].pnt[i][k] = atof(d);
			l++;
		}
		i++;
	}
	sprintf(data,"/fclose pntfile");
	sendmirc(mWnd,data);

	object[obj].npnts += n;
	sprintf(data,"%i Points Loaded. Total: %i",n,object[obj].npnts);
	return 3;
}
int __stdcall loadfcefile(
		HWND mWnd,
		HWND aWnd,
		char *data,
		char *parms,
		BOOL print,
		BOOL nopause) {

	// max 3 points per face
	// 1 = first pnt. [0] can be a centroid
	// can recall with more faces, start at face-one resets npnts 
  // loadfcefile(0:startindex:nfces:file)

	char s[99];
	int obj = atoi(data);
	int i = atoi(gettok(data,2,58));
	int n = atoi(gettok(data,3,58));

	sprintf(s,gettok(data,4,58));
	sprintf(data,"/fopen fcefile %s",s);
	sendmirc(mWnd,data);

	int  k = 0;
	if (i == 1) {
		object[obj].fce[0][0] = 0;
		object[obj].fce[0][1] = 0;
		object[obj].fce[0][2] = 0;
		object[obj].nfces = 0;
	}
	for (int j = 1;j<=n;j++) {
		sprintf(data,"$fread(fcefile)");
		evalmirc(mWnd,data);
		//if (numtok(data,32) == 3) l = 1;
    for (k = 0;k<3;k++) {
		  object[obj].fce[i][k] = atoi(gettok(data,k+1,32));
		}
		object[obj].fcecol[i] = atoi(gettok(data,4,58));
		i++;
	}
	sprintf(data,"/fclose fcefile");
	sendmirc(mWnd,data);
	object[obj].nfces += n;
	sprintf(data,"Object %i with %i Faces Loaded",obj,n);
	return 3;
}
int __stdcall memaccess(

		HWND mWnd,
		HWND aWnd,
		char *data,
		char *parms,
		BOOL print,
		BOOL nopause) {
	int i = atoi(data);
	if ((i < object[0].nfces) && (i < object[0].npnts))
	sprintf(data,"%f %f %f %i %i %i",
		object[0].pnt[i][0],object[0].pnt[i][1],object[0].pnt[i][2],
		object[0].fce[i][0], object[0].fce[i][1], object[0].fce[i][2]);
	else if (i < object[0].npnts)
		sprintf(data,"%f %f %f",
		object[0].pnt[i][0],object[0].pnt[i][1],object[0].pnt[i][2]);
	else if (i < object[0].nfces)
	sprintf(data,"%i %i %i",
		object[0].fce[i][0], object[0].fce[i][1], object[0].fce[i][2]);
	return 3;
}
int __stdcall loadfce(
		HWND mWnd,
		HWND aWnd,
		char *data,
		char *parms,
		BOOL print,
		BOOL nopause) {

	// max 3 points per face
	// 1 = first pnt. [0] can be a centroid
	// can recall with more faces, start at face-one resets npnts 
	// (index:obj:color:face pnt-indices:[multiple faces])

	char s[99];
	int nn, n = numtok(data,58) - 3;

	int i = atoi(data), k = 0;
	int obj = atoi(gettok(data,2,58));
	object[obj].fcecol[i] = atoi(gettok(data,3,58));
	if (i == 1) {
		object[obj].fce[0][0] = 0;
		object[obj].fce[0][1] = 0;
		object[obj].fce[0][2] = 0;
		object[obj].nfces = 0;
	}
	for (int j = 1;j<=n;j++) {

		sprintf(s,gettok(data,j+3,58));
		nn = numtok(s,32);
		if ((nn) && (s)) {
			for (k=1;k<=nn;k++) 
				object[obj].fce[i][k-1] = atoi(gettok(s,k,32));
		}
		i++;
	}
	object[obj].nfces += n;
	sprintf(data,"Object %i with %i Faces Loaded",obj,object[obj].nfces);
	return 3;
}
int __stdcall dobjbuf(
		HWND mWnd,
		HWND aWnd,
		char *data,
		char *parms,
		BOOL print,
		BOOL nopause) {
/*
  ; dll mircdll.dll drawobj @buf %drw.win %color %size %drw.cen.x %drw.cen.y
    ; 0-3 1-4 0-1 shownums focal-length(fol) %obj0matrix translate campos light
  ; 1 of 4 objects
  ; options of: draw-points wireframe shaderender sortfaces
  ; reverse norms
  ; shwnums 0-3 off front back both
	*/
	double x[3], lpos[3] = { 0.0,0.0,-15.0 };
	double y[3], campos[3];
	double z[3],av[3],bv[3],cv[3];
	double v[3];
	double v2[3];
	double v3[3], translate[3] = { 0.0,0.0,0.0 };
	double l1,l2;
	int r,g,b,fr,fg,fb,a,la, fil, frame;
	int j = 0, k = 0;
	int p1[2],p2[2],p3[2];
	char buf[16];
	sprintf(buf,gettok(data,1,32));
	char win[16];
	sprintf(win,gettok(data,2,32));

	int color1 = atoi(gettok(data,3,32)), color;
	double size = atof(gettok(data,4,32));
	int cenx = atoi(gettok(data,5,32));
	int ceny = atoi(gettok(data,6,32));
	int obj = atoi(gettok(data,7,32));
	int drawpfr = atoi(gettok(data,8,32));
	int reversenorms = atoi(gettok(data,9,32));
	int shownums = atoi(gettok(data,10,32));
	int fol = atoi(gettok(data,11,32));
	x[0] = atof(gettok(data,12,32));
	x[1] = atof(gettok(data,13,32));
	x[2] = atof(gettok(data,14,32));
	y[0] = atof(gettok(data,15,32));
	y[1] = atof(gettok(data,16,32));
	y[2] = atof(gettok(data,17,32));
	z[0] = atof(gettok(data,18,32));
	z[1] = atof(gettok(data,19,32));
	z[2] = atof(gettok(data,20,32));
	translate[0] = atof(gettok(data,21,32));
	translate[1] = atof(gettok(data,22,32));
	translate[2] = atof(gettok(data,23,32));
	campos[0] = atof(gettok(data,24,32));
	campos[1] = atof(gettok(data,25,32));
	campos[2] = atof(gettok(data,26,32));
	lpos[0] = atof(gettok(data,27,32));
	lpos[1] = atof(gettok(data,28,32));
	lpos[2] = atof(gettok(data,29,32));
	int intensity = 0;
	if (atof(gettok(data,30,32))) intensity =
		CLAMP(atoi(gettok(data,30,32)),-255,255);
	int ambience = 0;
	if (atof(gettok(data,31,32))) ambience = 
		CLAMP(atoi(gettok(data,31,32)),-255,255);

	int control[50000];
	double zs[50000];
	double max = -9999999999.0;
	int sx, sy,	bx,	by;
/*
	double m[16], i[16];
	m[0] = atof(data);
	for (int j = 1; j < 16; j++) {
		m[j] = atof(gettok(data,j+1,32));
	}
	if (invertmatrix(m, i))
*/
	for (int i = 1;i<=object[obj].npnts;i++) {
		// set matricized pnts
		COPYV(v3,object[obj].pnt[i]);

		MULTV(v,x,v3[0]);
		MULTV(v2,y,v3[1]);
		ADDV(v,v,v2);
		MULTV(v2,z,v3[2]);
		ADDV(v,v,v2);

		MULTV(v,v,size);
		SUBV(v,v,campos);	
		ADDV(v,v,translate);
		
		COPYV(object[obj].matp[i],v);
	}
	//set norms and Zs
	for (i = 1;i<=object[obj].nfces;i++) {
			// set norms, controls, draw backfaces
		COPYV(v,object[obj].matp[object[obj].fce[i][0]]);
		COPYV(v2,object[obj].matp[object[obj].fce[i][1]]);
		COPYV(v3,object[obj].matp[object[obj].fce[i][2]]);
		// incenter3d
		SUBV(av,v2,v3); SUBV(bv,v3,v); SUBV(cv,v,v2);
		l1 = VLEN(av) + VLEN(bv) + VLEN(cv);
/*
		zs[i] = v[0]*VLEN(av) + v2[0]*VLEN(bv) + v3[0]*VLEN(cv);
		zs[i] = zs[i] / l;
		object[obj].fce[0][0] = (int)floor(zs[i]);
		zs[i] = v[1]*VLEN(av) + v2[1]*VLEN(bv) + v3[1]*VLEN(cv);
		zs[i] = zs[i] / l;
		object[obj].fce[0][1] = (int)floor(zs[i]);
*/
		
		zs[i] = v[2]*VLEN(av) + v2[2]*VLEN(bv) + v3[2]*VLEN(cv);
		zs[i] = zs[i] / l1;

		control[i] = i;
		if (reversenorms)
			NORMALVECTOR(object[obj].normal[i], v3, v2, v);
		else NORMALVECTOR(object[obj].normal[i], v, v2, v3);
	}
	// sort faces
	for (i = 1;i<=object[obj].nfces;i++) {
		max = -9999999999.0;
		for (j = 1;j<=object[obj].nfces;j++) {
			if (zs[j] > max) {
				k = j;
				max = zs[j];
			}
		}
		control[i] = k;
		zs[k] = -9999999999.0;
	}

	for (i = 1;i<=object[obj].nfces;i++) {
		if (object[obj].fcecol[control[i]])
			color = object[obj].fcecol[control[i]];
		else color = color1;
		r = (int)floor(fmod((double)color, 256.0));
		g = (int)floor(fmod((double)color, 65536.0));
		g = (int)floor((g - r) / 256);
		b = (int)floor(color / 65536);
		fr = r; fg = g; fb = b;

		// amazingly this is all we need
		//la = (int)floor(rround(RAD2DEG(radang(lpos,object[obj].normal[control[i]])),0));
		la = (int)floor(RAD2DEG(radang(lpos,object[obj].normal[control[i]])));

		COPYV(v,object[obj].matp[object[obj].fce[control[i]][0]]);
		INITV(v2,0.0,0.0,1.0);
		l1 = radang(campos,object[obj].normal[control[i]]);
		l2 = radang3(campos,v2,v);
		a = (int)floor(RAD2DEG(l1-l2));
		// didnt work a = (int)floor(RAD2DEG(radang3(v,campos,object[obj].normal[control[i]])));
		
		fr-=la; fg-=la; fb-=la;
		if (fr<2) fr=2;
		if (fg<2) fg=2;
		if (fb<2) fb=2;

		if ((intensity) && (la < 90)) {
			fr = CLAMP((intensity+fr),2,255);
			fg = CLAMP((intensity+fg),2,255);
			fb = CLAMP((intensity+fb),2,255);
		}
		if (ambience) {
			fr = CLAMP((ambience+fr),2,255);
			fg = CLAMP((ambience+fg),2,255);
			fb = CLAMP((ambience+fb),2,255);
		}
		fil = (fr + fg * 256 + fb * 65536);
		fb -= 1;
		frame = (fr + fg * 256 + fb * 65536);
		
		COPYV(v2,object[obj].matp[object[obj].fce[control[i]][1]]);
		COPYV(v3,object[obj].matp[object[obj].fce[control[i]][2]]);

		p1[0] = (int)floor(((fol / (v[2])) * v[0]) + cenx);
		p1[1] = (int)floor(((fol / (v[2])) * v[1]) + ceny);
		p2[0] = (int)floor(((fol / (v2[2])) * v2[0]) + cenx);
		p2[1] = (int)floor(((fol / (v2[2])) * v2[1]) + ceny);
		p3[0] = (int)floor(((fol / (v3[2])) * v3[0]) + cenx);
		p3[1] = (int)floor(((fol / (v3[2])) * v3[1]) + ceny);

		if (drawpfr == 2) {
			sprintf(data, "/drawline -nr %s %i 1 %i %i %i %i %i %i %i %i",
				win,
				frame,
				p1[0],p1[1],p2[0],p2[1],p3[0],p3[1],p1[0],p1[1]
			);
			sendmirc(mWnd,data);
		}
		else if (drawpfr == 1) {
			sprintf(data, "/drawdot -nr %s %i 2 %i %i %i %i %i %i %i %i",
				win,
				frame,
				p1[0],p1[1],p2[0],p2[1],p3[0],p3[1],p1[0],p1[1]
			);
			sendmirc(mWnd,data);
		}
		

		if ((drawpfr == 3) && (a < 90)) {
			// for buf win

			sx = p1[0];
			if (p2[0] < sx) sx = p2[0];
			if (p3[0] < sx) sx = p3[0];
			bx = p1[0];
			if (p2[0] > bx) bx = p2[0];
			if (p3[0] > bx) bx = p3[0]; 

			sy = p1[1];
			if (p2[1] < sy) sy = p2[1];
			if (p3[1] < sy) sy = p3[1];
			by = p1[1];
			if (p2[1] > by) by = p2[1];
			if (p3[1] > by) by = p3[1];

			bx += 4;
			sx -=2;
			by += 4;
			sy -=2;

			if (((sx >= 0) && (bx <= (cenx*2)))
				&& ((sy >= 0) && (by <= (ceny*2)))) {

				bx -= sx;
				by -= sy;
				sprintf(data, "/drawrect -nrf %s %i 1 %i %i %i %i",
					buf,
					fil,
					sx,
					sy,
					bx,
					by
					);
				sendmirc(mWnd,data);

				sprintf(data, "/drawline -nr %s %i 1 %i %i %i %i %i %i %i %i",
					buf,
					frame,
					p1[0],p1[1],p2[0],p2[1],p3[0],p3[1],p1[0],p1[1]
				);
				sendmirc(mWnd,data);

				sprintf(data, "/drawrect -nr %s %i 1 %i %i %i %i",
					buf,
					frame,
					sx,
					sy,
					bx,
					by
					);
				sendmirc(mWnd,data);

				sprintf(data, "/drawfill -nr %s 65793 %i %i %i",
					buf,
					frame,
					sx + 1,
					sy + 1
				);
				sendmirc(mWnd,data);

				sprintf(data, "/drawcopy -nt %s 65793 %i %i %i %i %s %i %i",
					buf,
					sx + 1,
					sy + 1,
					bx - 2,
					by - 2,
					win,
					sx + 1,
					sy + 1
					);
				sendmirc(mWnd,data);
			}
		}
	}
	if (shownums) {
	for (i = 1;i<=object[obj].nfces;i++) {

		COPYV(v,object[obj].matp[object[obj].fce[control[i]][0]]);

		INITV(v2,0.0,0.0,1.0);
		l1 = radang(campos,object[obj].normal[control[i]]);
		l2 = radang3(campos,v2,v);
		a = (int)floor(RAD2DEG(l1-l2));

		COPYV(v2,object[obj].matp[object[obj].fce[control[i]][1]]);
		COPYV(v3,object[obj].matp[object[obj].fce[control[i]][2]]);
		p1[0] = (int)floor(((fol / (v[2])) * v[0]) + cenx);
		p1[1] = (int)floor(((fol / (v[2])) * v[1]) + ceny);
		p2[0] = (int)floor(((fol / (v2[2])) * v2[0]) + cenx);
		p2[1] = (int)floor(((fol / (v2[2])) * v2[1]) + ceny);
		p3[0] = (int)floor(((fol / (v3[2])) * v3[0]) + cenx);
		p3[1] = (int)floor(((fol / (v3[2])) * v3[1]) + ceny);
		
		if ((((shownums == 1) || (shownums == 3)) && (a < 90))
			|| ((shownums > 1) &&	(a >= 90))) {
			sprintf(data, "/drawtext -n %s 0 arial 10 %i %i %i",
				win,
				p1[0],p1[1],
				object[obj].fce[control[i]][0]
				);
			sendmirc(mWnd,data);
			sprintf(data, "/drawtext -n %s 0 arial 10 %i %i %i",
				win,
				p2[0],p2[1],
				object[obj].fce[control[i]][1]
				);
			sendmirc(mWnd,data);
			sprintf(data, "/drawtext -n %s 0 arial 10 %i %i %i",
				win,
				p3[0],p3[1],
				object[obj].fce[control[i]][2]
				);
			sendmirc(mWnd,data);
		}
	}
	} // help frame speed
	return 1;
}
int __stdcall smoothnorm2 (
		HWND mWnd,
		HWND aWnd,
		char *data,
		char *parms,
		BOOL print,
		BOOL nopause) {
	// (smooth limiter ike 70.0, scale, file,)
	double currnorm[3], norm[3], p[3];
	double nrm[25000][3];
	int obj = 0;
	double smooth = atof(data), newnorm[3], ang, v[3],v2[3],v3[3];
	double sz = atof(gettok(data,2,32));
	char f[99];
	int i = 1, j = 0, k = 0;
	sprintf(f,gettok(data,3,32));


	int frg = 1, frg2 = object[obj].nfces;
	//if (atoi(gettok(data,16,32))) frg = atoi(gettok(data,16,32));
	//if (atoi(gettok(data,17,32))) frg2 = atoi(gettok(data,17,32));

	for (i = 1;i<=object[obj].npnts;i++) {
		COPYV(v3,object[obj].pnt[i]);
		//REVY(v3);
		COPYV(object[obj].matp[i],v3);
		INITV(nrm[i],0.1, 0.1, 0.1);
	}

	for (i = 1;i<=object[obj].nfces;i++) {


		COPYV(v,object[obj].matp[object[obj].fce[i][0]]);
		COPYV(v2,object[obj].matp[object[obj].fce[i][1]]); 
		COPYV(v3,object[obj].matp[object[obj].fce[i][2]]);

    NORMALVECTOR(currnorm,v2,v,v3);
		NORMALIZE(currnorm);
			
    j = 0;
    while (j < 3) {
			COPYV(p,object[obj].matp[object[obj].fce[i][j]]);

			if (VLEN(nrm[object[obj].fce[i][j]]) > 0.9)
				COPYV(norm,nrm[object[obj].fce[i][j]]);
      else {
        INITV(norm,0.0,0.0,0.0);
        k = 0;
        while (k < object[obj].nfces) {
					k++;

					if ((object[obj].fce[i][j] == object[obj].fce[k][0]) ||
						(object[obj].fce[i][j] == object[obj].fce[k][1]) ||
						(object[obj].fce[i][j] == object[obj].fce[k][2]))
					
					{
						COPYV(v,object[obj].matp[object[obj].fce[k][0]]);
						COPYV(v2,object[obj].matp[object[obj].fce[k][1]]);
						COPYV(v3,object[obj].matp[object[obj].fce[k][2]]);

						NORMALVECTOR(newnorm,v2,v,v3);
						NORMALIZE(newnorm);
						ang = RAD2DEG(radang(currnorm,newnorm));
						if ((ang < smooth) && (ang > 0.1)) ADDV(norm,norm,newnorm);
					}
        } //while k
				NORMALIZE(norm);
				if (!((norm[0] == 0.0) && (norm[1] == 0.0) &&
					(norm[2] == 0.0)))
					COPYV(nrm[object[obj].fce[i][j]],norm);
      } // else
      if ((norm[0] == 0.0) && (norm[1] == 0.0) &&
				(norm[2] == 0.0)) COPYV(norm,currnorm);

			j++;
		} // while j 3
	} // for i faces
	sprintf(data,"/write %s normal_vectors {",f);
	sendmirc(mWnd,data);
	sprintf(data,"/write %s %i%s",
		f,object[obj].npnts,",");
	sendmirc(mWnd,data);
	for (i = 1;i<=object[obj].npnts;i++) {
			if (i == object[obj].npnts) sprintf(data,"/write %s <%f%s%f%s%f>",
					f,
					nrm[i][0],
					",",
					nrm[i][1],
					",",
					nrm[i][2]
			);
			else sprintf(data,"/write %s <%f%s%f%s%f>%s",
					f,
					nrm[i][0],
					",",
					nrm[i][1],
					",",
					nrm[i][2],
					","
			);
			sendmirc(mWnd,data);
	}
	sprintf(data,"/write %s }",f);
	sendmirc(mWnd,data);


	sprintf(data,"/write %s normal_indices {",f);
	sendmirc(mWnd,data);

	sprintf(data,"/write %s %i%s",f,object[obj].nfces,",");
	sendmirc(mWnd,data);

	for (i = 1;i<=object[obj].nfces;i++) {
			if (i == object[obj].nfces) sprintf(data,"/write %s <%i%s%i%s%i>",
					f,
					object[obj].fce[i][0] - 1,
					",",
					object[obj].fce[i][1] - 1,
					",",
					object[obj].fce[i][2] - 1
			);
			else sprintf(data,"/write %s <%i%s%i%s%i>%s",
					f,
					object[obj].fce[i][0] - 1,
					",",
					object[obj].fce[i][1] - 1,
					",",
					object[obj].fce[i][2] - 1,
					","
			);
			sendmirc(mWnd,data);
	}
	sprintf(data,"/write %s }",f);
	sendmirc(mWnd,data);
	return 1;
}
int __stdcall smoothnorm (
		HWND mWnd,
		HWND aWnd,
		char *data,
		char *parms,
		BOOL print,
		BOOL nopause) {
	// (smooth limiter ike 70.0, scale, file, m)
	double currnorm[3], norm[3], p[3], w[3];
	double nrm[25000][3];
	int obj = 0;
	double smooth = atof(data), newnorm[3], ang, v[3],v2[3],v3[3];
	double sz = atof(gettok(data,2,32));
	char f[99];
	int i = 1, j = 0, k = 0;
	sprintf(f,gettok(data,3,32));
	double x[3], y[3], z[3];
	x[0] = atof(gettok(data,4,32));
	x[1] = atof(gettok(data,5,32));
	x[2] = atof(gettok(data,6,32));
	y[0] = atof(gettok(data,7,32));
	y[1] = atof(gettok(data,8,32));
	y[2] = atof(gettok(data,9,32));
	z[0] = atof(gettok(data,10,32));
	z[1] = atof(gettok(data,11,32));
	z[2] = atof(gettok(data,12,32));
	w[0] = atof(gettok(data,13,32));
	w[1] = atof(gettok(data,14,32));
	w[2] = atof(gettok(data,15,32));

	int frg = 1, frg2 = object[obj].nfces;
	if (atoi(gettok(data,16,32))) frg = atoi(gettok(data,16,32));
	if (atoi(gettok(data,17,32))) frg2 = atoi(gettok(data,17,32));

	for (i = 1;i<=object[obj].npnts;i++) {
		// set matricized pnts
		COPYV(v3,object[obj].pnt[i]);
/*
		MULTV(v,x,v3[0]);
		MULTV(v2,y,v3[1]);
		ADDV(v,v,v2);
		MULTV(v2,z,v3[2]);
		ADDV(v,v,v2);
		*/
		REVY(v3);
		COPYV(object[obj].matp[i],v3);
		INITV(nrm[i],0.1, 0.1, 0.1);
	}

	for (i = frg;i<=frg2;i++) {
    //write f smooth_triangle $chr(123)
		sprintf(data,"/write %s smooth_triangle {",f);
		sendmirc(mWnd,data);
		COPYV(v,object[obj].matp[object[obj].fce[i][0]]);
		COPYV(v2,object[obj].matp[object[obj].fce[i][1]]);
		COPYV(v3,object[obj].matp[object[obj].fce[i][2]]);

    NORMALVECTOR(currnorm,v2,v,v3);
		NORMALIZE(currnorm);
			
    j = 0;
    while (j < 3) {
			COPYV(p,object[obj].matp[object[obj].fce[i][j]]);
			//object[obj].fce[i][j];
			//p;
			if (VLEN(nrm[object[obj].fce[i][j]]) > 0.9)
				COPYV(norm,nrm[object[obj].fce[i][j]]);
      else {
        INITV(norm,0.0,0.0,0.0);
        k = 0;
        while (k < object[obj].nfces) {
					k++;

					if ((object[obj].fce[i][j] == object[obj].fce[k][0]) ||
						(object[obj].fce[i][j] == object[obj].fce[k][1]) ||
						(object[obj].fce[i][j] == object[obj].fce[k][2]))
					
					{
						COPYV(v,object[obj].matp[object[obj].fce[k][0]]);
						COPYV(v2,object[obj].matp[object[obj].fce[k][1]]);
						COPYV(v3,object[obj].matp[object[obj].fce[k][2]]);

						NORMALVECTOR(newnorm,v2,v,v3);
						NORMALIZE(newnorm);
						ang = RAD2DEG(radang(currnorm,newnorm));
						if ((ang < smooth) && (ang > 0.1)) ADDV(norm,norm,newnorm);
					}
        } //while k
				NORMALIZE(norm);
				if (!((norm[0] == 0.0) && (norm[1] == 0.0) &&
					(norm[2] == 0.0)))
					COPYV(nrm[object[obj].fce[i][j]],norm);
      } // else
      if ((norm[0] == 0.0) && (norm[1] == 0.0) &&
				(norm[2] == 0.0)) COPYV(norm,currnorm);
			MULTV(p,p,sz);
			SUBV(p,p,w);
			// centered for mapping
			// 1 of 3 point and normal finished
			
			sprintf(data,"/write %s <%f%s%f%s%f>%s",
					f,
					p[0],
					",",
					p[1],
					",",
					p[2],
					","
			);
			sendmirc(mWnd,data);
			if (j == 2) sprintf(data,"/write %s <%f%s%f%s%f>",
					f,
					norm[0],
					",",
					norm[1],
					",",
					norm[2]
			);
			else sprintf(data,"/write %s <%f%s%f%s%f>%s",
					f,
					norm[0],
					",",
					norm[1],
					",",
					norm[2],
					","
			);
			sendmirc(mWnd,data);
			j++;
		} // while j 3
		sprintf(data,"/write %s }",f);
		sendmirc(mWnd,data);
	} // for i faces
	return 1;
}
void incenter(int p1[2],int p2[2],int p3[2]) {
	double v[2];
	SUBV2(v,p2,p3);
	double l1 = VLEN2(v);
	SUBV2(v,p1,p3);
	double l2 = VLEN2(v);
	SUBV2(v,p1,p2);
	double l3 = VLEN2(v);
	double d = l1 + l2 + l2;	

	p1[0] = (int)floor((l1 * p1[0] + l2 * p2[0] + l3 * p3[0]) / d);
	p1[1] = (int)floor((l1 * p1[1] + l2 * p2[1] + l3 * p3[1]) / d);

}

void sendmirc(HWND hwnd, char *data) {
  HANDLE hmap, hmutex;
  char *ptr;

  // create the filemapping object
  if ((hmap = CreateFileMapping(INVALID_HANDLE_VALUE, NULL, PAGE_READWRITE,
   0, 1024, "mIRC")) == NULL) return;

  // at this point we SHOULD check GetLastError() to see if it's set to
  // ERROR_ALREADY_EXISTS; that's how mIRC prescribes that it must be done,
  // and if all DLL coders did this, we would not need a mutex at all.

  // map the shared memory onto our address space
  if ((ptr = (char *)MapViewOfFile(hmap, FILE_MAP_ALL_ACCESS, 0, 0, 0)) == NULL) {
    CloseHandle(hmap);

    return;
  }

  // the creation and mapping of the virtual file done so far, can not lead to
  // synchronization problems on itself; we only need to protect actual access

  // so, create or open a mutex that will protect the shared memory access
  if ((hmutex = CreateMutex(NULL, FALSE, "mIRC_SendMessage")) != NULL) {

    // wait for this mutex to be released - if it is currently locked, wait!
    WaitForSingleObject(hmutex, INFINITE);

    // now that we hold the mutex, we can access the shared memory safely
    lstrcpyn(ptr, data, 1024);

    // and tell mIRC to execute our command
    SendMessage(hwnd, WM_MCOMMAND, 0, NULL);

    // release and destroy the mutex
    ReleaseMutex(hmutex);

    CloseHandle(hmutex);
  }

  // unmap and close the filemapping
  UnmapViewOfFile(ptr);

  CloseHandle(hmap);
}

void evalmirc(HWND hwnd, char *data) {
  HANDLE hmap, hmutex;
  char *ptr;

  // create the filemapping object
  if ((hmap = CreateFileMapping(INVALID_HANDLE_VALUE, NULL, PAGE_READWRITE,
   0, 1024, "mIRC")) == NULL) return;

  // at this point we SHOULD check GetLastError() to see if it's set to
  // ERROR_ALREADY_EXISTS; that's how mIRC prescribes that it must be done,
  // and if all DLL coders did this, we would not need a mutex at all.

  // map the shared memory onto our address space
  if ((ptr = (char *)MapViewOfFile(hmap, FILE_MAP_ALL_ACCESS, 0, 0, 0)) == NULL) {
    CloseHandle(hmap);

    return;
  }

  // the creation and mapping of the virtual file done so far, can not lead to
  // synchronization problems on itself; we only need to protect actual access

  // so, create or open a mutex that will protect the shared memory access
  if ((hmutex = CreateMutex(NULL, FALSE, "mIRC_SendMessage")) != NULL) {

    // wait for this mutex to be released - if it is currently locked, wait!
    WaitForSingleObject(hmutex, INFINITE);

    // now that we hold the mutex, we can access the shared memory safely
    lstrcpyn(ptr, data, 1024);

    // and tell mIRC to execute our command
    SendMessage(hwnd, WM_MEVALUATE, 0, NULL);
		sprintf(data,ptr);
    // release and destroy the mutex
    ReleaseMutex(hmutex);

    CloseHandle(hmutex);
  }

  // unmap and close the filemapping
  UnmapViewOfFile(ptr);

  CloseHandle(hmap);
}
int numtok(char *d, int sep) {
	char *p;
	char str[1024];
	sprintf(str, "%s", d);
	const char *a = (const char *)&sep;
	int i = 0;
  p = strtok(str,a);
  while (p != NULL) {
		i++;
    p = strtok(NULL, a);
  }
	return i;
}
int __stdcall lgettokk(HWND mWnd,
					  HWND aWnd,
					  char *data,
					  char *parms,
					  BOOL print,
					  BOOL nopause)
{
	char s[1024];
	sprintf(s,"%s",data);
	int n = numtok(s,32);
	int t = atoi(gettok(s,n-1,32));
	int sep = atoi(gettok(s,n,32));
	// deltok leaves no trailing sep char making this export possible
	// A space would make a token for other sep chars as ":".
	// using string token# ascii-separator-char
	deltok(s,n,32);
	deltok(s,n-1,32);
	n = numtok(s,sep);

	_gettok(s,t,sep);
	sprintf(data,"%s",s);

	return 3;
}
int _numtok(char *d, int sep) {
	int p = 0, i = 0, sep_encounterd = 1;
	while (d[p]) {
		if ((d[p] != sep) && sep_encounterd) {
			i++;
			sep_encounterd = 0;
		}
		if (d[p] == sep) sep_encounterd = 1;
		p++;
	}
	return i;
}
void _deltok(char *d, int t, int sep) {
	int p = 0;
	int des = 0;
	int i = 1;
	while (d[p]) {
		if (i != t) d[des++] = d[p];
		if ((d[p] == sep) && (p)) {
			if (d[p-1] != sep) i++;
		}
		// to count existing tokens,ignoring multi spacers,
		// if (d[p-1] != sep) i++;
		// (p) for if the first char is a spacer, still on 1st tok
		p++;
	}
	if (d[des-1] == sep) d[des-1] = 0;
	else d[des] = 0;
}
void _gettok(char *d, int t, int sep) {
	int p = 0;
	int des = 0;
	int i = 1;
	// i counts tokens
	if (t > 0) {
	while (d[p]) {
		//if the first char is a spacer and we want first token, then
		//we just printed a separator-spacer char. adding: && (d[p] != sep)
		if ((i == t) && (d[p] != sep)) d[des++] = d[p];
		if ((d[p] == sep) && (p)) {
			if (d[p-1] != sep) i++;
		}
		p++;
	}
	d[des] = 0;
	}
	else sprintf(d,"%i",_numtok(d,sep));
}
int numtokk(char *d, int sep) {
	int p = 0, i = 0;
	while (d[p]) {
		if (d[p] == sep) i++;
		p++;
	}
	//if the last one was sep, dec because
	//  we started counting first sep
	if ((d[p - 1] == sep) && (d[0] == sep)) i--;
	if ((d[p - 1] != sep) && (d[0] != sep)) i++;
	return i;
}
void deltok(char *d, int t, int sep) {
	int p = 0;
	int des = 0;
	int i = 1;
	// i counts spacers
	while (d[p]) {
		if (i != t) d[des++] = d[p];
		if ((d[p] == sep) && (p)) i++;
		// to count existing tokens,ignoring multi spacers,
		// add: if (d[p-1] != sep) i++;
		// (p) for if the first char is a spacer, still on 1st tok
		p++;
	}
	if (d[des-1] == sep) d[des-1] = 0;
	else d[des] = 0;
}
// by that logic gettok2, should be mod'd to return more than single token
void gettokk(char *d, int t, int sep) {
	int p = 0;
	int des = 0;
	int i = 1;
	// i counts spacers
	if (t > 0) {
	while (d[p]) {
		//if the first char is a spacer and we want first token, then
		//we just printed a separater-spacer char. adding: && (d[p] != sep)
		if ((i == t) && (d[p] != sep)) d[des++] = d[p];
		if ((d[p] == sep) && (p)) i++;
		p++;
	}
	d[des] = 0;
	}
	else sprintf(d,"%i",numtokk(d,sep));
}
int __stdcall setrndlst(
		HWND mWnd,
		HWND aWnd,
		char *data,
		char *parms,
		BOOL print,
		BOOL nopause)
{
	int j = atoi(data);
	// for sorting
	numrend = j;
	rendlist[j].id = atoi(gettok(data,2,32));
	rendlist[j].labelc = atoi(gettok(data,3,32));
	rendlist[j].x = atoi(gettok(data,4,32));
	rendlist[j].y = atoi(gettok(data,5,32));
	rendlist[j].z = atof(gettok(data,6,32));

	return 1;
}
int __stdcall rlstacc(
	HWND mWnd,
  HWND aWnd,
  char *data,
  char *parms,
  BOOL print,
  BOOL nopause)
{
	int j = atoi(data);
	sprintf(data,"%i %i %i %i %f",
		rendlist[j].id,
		rendlist[j].labelc,
		rendlist[j].x,
		rendlist[j].y,
		rendlist[j].z);
	return 3;
	// sprintf(data,"%s",(char *)rendlist[j]);?

}
int __stdcall sortrlist(
	HWND mWnd,
  HWND aWnd,
  char *data,
  char *parms,
  BOOL print,
  BOOL nopause)
{
		renddata pd[160];

    int i=0, k=0, is;
		int n = numrend;
		int nr = n;
		double d = 0.0;

  if (numrend) {
    for (int j=0;j <= nr;j++) {
			for (i = 0;i <= n;i++) {
				if (rendlist[i].z > d) {
					d = rendlist[i].z;
					is = i;
				}
			}
			pd[j] = rendlist[is];
			for (k=is;k<n;k++)
				rendlist[k] = rendlist[k+1];
			d = 0.0;
			n--;
    }
		for (k=0;k<=nr;k++) rendlist[k] = pd[k];
  }
	return 1;
}

int __stdcall invmatrix(HWND mWnd,
					  HWND aWnd,
					  char *data,
					  char *parms,
					  BOOL print,
					  BOOL nopause)
{
	if (data) {
		double m[16], i[16];
		m[0] = atof(data);
		for (int j = 1; j < 16; j++) {
				m[j] = atof(gettok(data,j+1,32));
		}
		if (invertmatrix(m, i)) {
			sprintf(data,"%f %f %f %f %f %f %f %f %f %f %f %f %f %f %f %f",
				i[0],i[1],i[2],i[3],i[4],
				i[5],i[6],i[7],i[8],i[9],
				i[10],i[11],i[12],i[13],i[14],i[15]);
			return 3;
		}
		else {
			sprintf(data,"%i",0);
			return 3;
		}
	}
	return 0;
}
#define SWAP_ROWS(a, b) { double *_tmp = a; (a)=(b); (b)=_tmp; }
#define MAT(m,r,c) m[(c)*4+(r)]
int invertmatrix(double mat[16], double inv[16])
{
	double *m = mat;
	double *out = inv;
	double wtmp[4][8];
	double m0, m1, m2, m3, s;
	double *r0, *r1, *r2, *r3;

	r0 = wtmp[0], r1 = wtmp[1], r2 = wtmp[2], r3 = wtmp[3];

	r0[0] = MAT(m, 0, 0), r0[1] = MAT(m, 0, 1),
		r0[2] = MAT(m, 0, 2), r0[3] = MAT(m, 0, 3),
		r0[4] = 1.0, r0[5] = r0[6] = r0[7] = 0.0,
		r1[0] = MAT(m, 1, 0), r1[1] = MAT(m, 1, 1),
		r1[2] = MAT(m, 1, 2), r1[3] = MAT(m, 1, 3),
		r1[5] = 1.0, r1[4] = r1[6] = r1[7] = 0.0,
		r2[0] = MAT(m, 2, 0), r2[1] = MAT(m, 2, 1),
		r2[2] = MAT(m, 2, 2), r2[3] = MAT(m, 2, 3),
		r2[6] = 1.0, r2[4] = r2[5] = r2[7] = 0.0,
		r3[0] = MAT(m, 3, 0), r3[1] = MAT(m, 3, 1),
		r3[2] = MAT(m, 3, 2), r3[3] = MAT(m, 3, 3),
		r3[7] = 1.0, r3[4] = r3[5] = r3[6] = 0.0;

	/* choose pivot - or die */
	if (fabs(r3[0]) > fabs(r2[0]))
		SWAP_ROWS(r3, r2);
	if (fabs(r2[0]) > fabs(r1[0]))
		SWAP_ROWS(r2, r1);
	if (fabs(r1[0]) > fabs(r0[0]))
		SWAP_ROWS(r1, r0);
	if (0.0 == r0[0])
		return 0;

	/* eliminate first variable     */
	m1 = r1[0] / r0[0];
	m2 = r2[0] / r0[0];
	m3 = r3[0] / r0[0];
	s = r0[1];
	r1[1] -= m1 * s;
	r2[1] -= m2 * s;
	r3[1] -= m3 * s;
	s = r0[2];
	r1[2] -= m1 * s;
	r2[2] -= m2 * s;
	r3[2] -= m3 * s;
	s = r0[3];
	r1[3] -= m1 * s;
	r2[3] -= m2 * s;
	r3[3] -= m3 * s;
	s = r0[4];
	if (s != 0.0) {
		r1[4] -= m1 * s;
		r2[4] -= m2 * s;
		r3[4] -= m3 * s;
	}
	s = r0[5];
	if (s != 0.0) {
		r1[5] -= m1 * s;
		r2[5] -= m2 * s;
		r3[5] -= m3 * s;
	}
	s = r0[6];
	if (s != 0.0) {
		r1[6] -= m1 * s;
		r2[6] -= m2 * s;
		r3[6] -= m3 * s;
	}
	s = r0[7];
	if (s != 0.0) {
		r1[7] -= m1 * s;
		r2[7] -= m2 * s;
		r3[7] -= m3 * s;
	}

	/* choose pivot - or die */
	if (fabs(r3[1]) > fabs(r2[1]))
		SWAP_ROWS(r3, r2);
	if (fabs(r2[1]) > fabs(r1[1]))
		SWAP_ROWS(r2, r1);
	if (0.0 == r1[1])
		return 0;

	/* eliminate second variable */
	m2 = r2[1] / r1[1];
	m3 = r3[1] / r1[1];
	r2[2] -= m2 * r1[2];
	r3[2] -= m3 * r1[2];
	r2[3] -= m2 * r1[3];
	r3[3] -= m3 * r1[3];
	s = r1[4];
	if (0.0 != s) {
		r2[4] -= m2 * s;
		r3[4] -= m3 * s;
	}
	s = r1[5];
	if (0.0 != s) {
		r2[5] -= m2 * s;
		r3[5] -= m3 * s;
	}
	s = r1[6];
	if (0.0 != s) {
		r2[6] -= m2 * s;
		r3[6] -= m3 * s;
	}
	s = r1[7];
	if (0.0 != s) {
		r2[7] -= m2 * s;
		r3[7] -= m3 * s;
	}

	/* choose pivot - or die */
	if (fabs(r3[2]) > fabs(r2[2]))
		SWAP_ROWS(r3, r2);
	if (0.0 == r2[2])
		return 0;

	/* eliminate third variable */
	m3 = r3[2] / r2[2];
	r3[3] -= m3 * r2[3], r3[4] -= m3 * r2[4],
		r3[5] -= m3 * r2[5], r3[6] -= m3 * r2[6], r3[7] -= m3 * r2[7];

	/* last check */
	if (0.0 == r3[3])
		return 0;

	s = 1.0 / r3[3];			/* now back substitute row 3 */
	r3[4] *= s;
	r3[5] *= s;
	r3[6] *= s;
	r3[7] *= s;

	m2 = r2[3];					/* now back substitute row 2 */
	s = 1.0 / r2[2];
	r2[4] = s * (r2[4] - r3[4] * m2), r2[5] = s * (r2[5] - r3[5] * m2),
		r2[6] = s * (r2[6] - r3[6] * m2), r2[7] = s * (r2[7] - r3[7] * m2);
	m1 = r1[3];
	r1[4] -= r3[4] * m1, r1[5] -= r3[5] * m1,
		r1[6] -= r3[6] * m1, r1[7] -= r3[7] * m1;
	m0 = r0[3];
	r0[4] -= r3[4] * m0, r0[5] -= r3[5] * m0,
		r0[6] -= r3[6] * m0, r0[7] -= r3[7] * m0;

	m1 = r1[2];					/* now back substitute row 1 */
	s = 1.0 / r1[1];
	r1[4] = s * (r1[4] - r2[4] * m1), r1[5] = s * (r1[5] - r2[5] * m1),
		r1[6] = s * (r1[6] - r2[6] * m1), r1[7] = s * (r1[7] - r2[7] * m1);
	m0 = r0[2];
	r0[4] -= r2[4] * m0, r0[5] -= r2[5] * m0,
		r0[6] -= r2[6] * m0, r0[7] -= r2[7] * m0;

	m0 = r0[1];					/* now back substitute row 0 */
	s = 1.0 / r0[0];
	r0[4] = s * (r0[4] - r1[4] * m0), r0[5] = s * (r0[5] - r1[5] * m0),
		r0[6] = s * (r0[6] - r1[6] * m0), r0[7] = s * (r0[7] - r1[7] * m0);

	MAT(out, 0, 0) = r0[4];
	MAT(out, 0, 1) = r0[5], MAT(out, 0, 2) = r0[6];
	MAT(out, 0, 3) = r0[7], MAT(out, 1, 0) = r1[4];
	MAT(out, 1, 1) = r1[5], MAT(out, 1, 2) = r1[6];
	MAT(out, 1, 3) = r1[7], MAT(out, 2, 0) = r2[4];
	MAT(out, 2, 1) = r2[5], MAT(out, 2, 2) = r2[6];
	MAT(out, 2, 3) = r2[7], MAT(out, 3, 0) = r3[4];
	MAT(out, 3, 1) = r3[5], MAT(out, 3, 2) = r3[6];
	MAT(out, 3, 3) = r3[7];

	return 1;
}

int __stdcall isloaded(
						HWND mWnd,
					  HWND aWnd,
					  char *data,
					  char *parms,
					  BOOL print,
					  BOOL nopause)
{
	if (dll) sprintf(data,"%i", dll);
	else sprintf(data,"0");
	return 3;
}
int __stdcall unload(
						HWND mWnd,
					  HWND aWnd,
					  char *data,
					  char *parms,
					  BOOL print,
					  BOOL nopause)
{
	int f = FreeLibrary(dll);
	if (f) sprintf(data,"echo -s unLoad Successful %i", f);
	else sprintf(data,"echo -s unLoad Failed %i", f);
	return 2;

}
int __stdcall load(
						HWND mWnd,
					  HWND aWnd,
					  char *data,
					  char *parms,
					  BOOL print,
					  BOOL nopause)
{
	dll = LoadLibrary("meshview.dll");
	if (dll) {
		sprintf(data,"echo -s Load Successful %i", dll); 
		//initdata();
	}
	else sprintf(data,"echo -s Load Failed");
	return 2;
}
int __stdcall dadd(HWND mWnd,
					  HWND aWnd,
					  char *data,
					  char *parms,
					  BOOL print,
					  BOOL nopause)
{
	if (data) {
		sprintf(data,"%.15f",
			atof(data)
			+ atof(gettok(data,2,32))
			);
		for (int i=strlen(data);i>0;i--) {
			if (data[i] == '0') data[i] = 0;
			if (data[i-1] != '0') break;
			if (data[i-2] == '.') break;
		}
 		return 3;
	}
	return 0;
	/*
	static char *p;
  int n;
  if (data) {
    p = strchr(data, ' ');
    if (p) {
	*p = 0;
      n = atoi(data);
	p++;
	if (*p) n += atoi(p);
    }
    else n = atoi(data);
    wsprintf(data, "%d\0", n);
    return 3;
  } */
}
int __stdcall bitwise(HWND mWnd,
					  HWND aWnd,
					  char *data,
					  char *parms,
					  BOOL print,
					  BOOL nopause)
{
	if (data) {
		int a = atoi(data);
		a = a | atoi(gettok(data,2,32));
		sprintf(data, "%i",a);
		return 3;
	}
	return 0;
}
int __stdcall bitequals(HWND mWnd,
					  HWND aWnd,
					  char *data,
					  char *parms,
					  BOOL print,
					  BOOL nopause)
{
	if (data) {
		int a = atoi(data);
		a |= atoi(gettok(data,2,32));
		sprintf(data, "%i",a);
		return 3;
	}
	return 0;
}
int __stdcall bitshiftl(HWND mWnd,
					  HWND aWnd,
					  char *data,
					  char *parms,
					  BOOL print,
					  BOOL nopause)
{
	if (data) {
		unsigned int bit =
		 (unsigned int)atoi(data) <<
		  (unsigned int)atoi(gettok(data,2,32));
		sprintf(data, "%i",bit);
		return 3;
	}
	return 3;
}
int __stdcall bitshiftr(HWND mWnd,
					  HWND aWnd,
					  char *data,
					  char *parms,
					  BOOL print,
					  BOOL nopause)
{
	if (data) {
		unsigned int bit =
		 (unsigned int)atoi(data) >>
		  (unsigned int)atoi(gettok(data,2,32));
		sprintf(data, "%i",bit);
		return 3;
	}
	return 3;
}
int __stdcall dlog(HWND mWnd,
					  HWND aWnd,
					  char *data,
					  char *parms,
					  BOOL print,
					  BOOL nopause)
{
	if (data) {
 		sprintf(data,"%.15f",
			log(atof(data))
			);
		for (int i=strlen(data);i>0;i--) {
			if (data[i] == '0') data[i] = 0;
			if (data[i-1] != '0') break;
			if (data[i-2] == '.') break;
		}
 		return 3;
	}
	return 0;
}
	
int __stdcall dsub(HWND mWnd,
					  HWND aWnd,
					  char *data,
					  char *parms,
					  BOOL print,
					  BOOL nopause)
{
	if (data) {
 		sprintf(data,"%.15f",
			atof(data)
			- atof(gettok(data,2,32))
			);
		for (int i=strlen(data);i>0;i--) {
			if (data[i] == '0') data[i] = 0;
			if (data[i-1] != '0') break;
			if (data[i-2] == '.') break;
		}
 		return 3;
	}
	return 0;
}
int __stdcall dmod(HWND mWnd,
					  HWND aWnd,
					  char *data,
					  char *parms,
					  BOOL print,
					  BOOL nopause)
{
	if (data) {
		sprintf(data,"%.15f",fmod(atof(data),
			atof(gettok(data,2,32))));
		for (int i=strlen(data);i>0;i--) {
			if (data[i] == '0') data[i] = 0;
			if (data[i-1] != '0') break;
			if (data[i-2] == '.') break;
		}
		return 3;
	}
	return 0;
}
int __stdcall dsqrt(HWND mWnd,
					  HWND aWnd,
					  char *data,
					  char *parms,
					  BOOL print,
					  BOOL nopause)
{
	if (data) {
		sprintf(data,"%.15f", sqrt(atof(data)));
		for (int i=strlen(data);i>0;i--) {
			if (data[i] == '0') data[i] = 0;
			if (data[i-1] != '0') break;
			if (data[i-2] == '.') break;
		}
		return 3;
	}
	return 0;
}
int __stdcall dasin(HWND mWnd,
					  HWND aWnd,
					  char *data,
					  char *parms,
					  BOOL print,
					  BOOL nopause)
{
	if (data) {
		sprintf(data,"%.15f",asin(atof(data)));
		for (int i=strlen(data);i>0;i--) {
			if (data[i] == '0') data[i] = 0;
			if (data[i-1] != '0') break;
			if (data[i-2] == '.') break;
		}
		return 3;
	}

	return 0;
}
int __stdcall dsin(HWND mWnd,
					  HWND aWnd,
					  char *data,
					  char *parms,
					  BOOL print,
					  BOOL nopause)
{
	if (data) {
		sprintf(data,"%.15f", sin(atof(data)));
		for (int i=strlen(data);i>0;i--) {
			if (data[i] == '0') data[i] = 0;
			if (data[i-1] != '0') break;
			if (data[i-2] == '.') break;
		}
		return 3;
	}

	return 0;
}
int __stdcall dcos(HWND mWnd,
					  HWND aWnd,
					  char *data,
					  char *parms,
					  BOOL print,
					  BOOL nopause)
{
	if (data) {
		sprintf(data,"%.15f", cos(atof(data)));
		for (int i=strlen(data);i>0;i--) {
			if (data[i] == '0') data[i] = 0;
			if (data[i-1] != '0') break;
			if (data[i-2] == '.') break;
		}
		return 3;
	}
	return 0;
}
int __stdcall dacos(HWND mWnd,
					  HWND aWnd,
					  char *data,
					  char *parms,
					  BOOL print,
					  BOOL nopause)
{
	if (data) {
		sprintf(data,"%.15f", acos(atof(data)));
		for (int i=strlen(data);i>0;i--) {
			if (data[i] == '0') data[i] = 0;
			if (data[i-1] != '0') break;
			if (data[i-2] == '.') break;
		}
		return 3;
	}
	return 0;
}
int __stdcall dpow(HWND mWnd,
					  HWND aWnd,
					  char *data,
					  char *parms,
					  BOOL print,
					  BOOL nopause)
{
	if (data) {
		sprintf(data,"%.15f",pow(atof(data),
			atof(gettok(data,2,32)))
			);
		for (int i=strlen(data);i>0;i--) {
			if (data[i] == '0') data[i] = 0;
			if (data[i-1] != '0') break;
			if (data[i-2] == '.') break;
		}
		return 3;
	}
	return 0;
}
int __stdcall dmult(HWND mWnd,
					  HWND aWnd,
					  char *data,
					  char *parms,
					  BOOL print,
					  BOOL nopause)
{
	if (data) {
		sprintf(data,"%.15f",(atof(data) * atof(gettok(data,2,32))));
		// at %.16f sprintf fails and (0.63*10) becomes 6.29999999
		for (int i=strlen(data);i>0;i--) {
			if (data[i] == '0') data[i] = 0;
			if (data[i-1] != '0') break;
			if (data[i-2] == '.') break;
		}
		return 3;
	}
	return 0;
}
int __stdcall ddiv(HWND mWnd,
					  HWND aWnd,
					  char *data,
					  char *parms,
					  BOOL print,
					  BOOL nopause)
{
	if (data) {
		sprintf(data,"%.15f",(atof(data) / atof(gettok(data,2,32))));
		for (int i=strlen(data);i>0;i--) {
			if (data[i] == '0') data[i] = 0;
			if (data[i-1] != '0') break;
			if (data[i-2] == '.') break;
		}
		return 3;
	}
	return 0;
}
int __stdcall fmult(HWND mWnd,
					  HWND aWnd,
					  char *data,
					  char *parms,
					  BOOL print,
					  BOOL nopause)
{
	if (data) {
		sprintf(data,"%.15e",(atof(data) * atof(gettok(data,2,32))));
		return 3;
	}
	return 0;
}
int __stdcall fdiv(HWND mWnd,
					  HWND aWnd,
					  char *data,
					  char *parms,
					  BOOL print,
					  BOOL nopause)
{
	if (data) {
		sprintf(data,"%.15e",(atof(data) / atof(gettok(data,2,32))));
		return 3;
	}
	return 0;
}

int __stdcall datan2(HWND mWnd,
					  HWND aWnd,
					  char *data,
					  char *parms,
					  BOOL print,
					  BOOL nopause)
{
	if (data) {
		sprintf(data,"%.15f", atan2(atof(data),atof(gettok(data,2,32))));
		for (int i=strlen(data);i>0;i--) {
			if (data[i] == '0') data[i] = 0;
			if (data[i-1] != '0') break;
			if (data[i-2] == '.') break;
		}
		return 3;
	}
	return 0;
}
int __stdcall datan(HWND mWnd,
					  HWND aWnd,
					  char *data,
					  char *parms,
					  BOOL print,
					  BOOL nopause)
{
	if (data) {
		sprintf(data,"%.15f", atan(atof(data)));
		for (int i=strlen(data);i>0;i--) {
			if (data[i] == '0') data[i] = 0;
			if (data[i-1] != '0') break;
			if (data[i-2] == '.') break;
		}
		return 3;
	}
	return 0;
}
int getdot(HWND mWnd, char *win,int i,int j) {
	char data[90];
	sprintf(data,"$getdot(%s%s%i%s%i)",
		win,",",i,",",j);
		evalmirc(mWnd,data);
	return atoi(data);
}
double _quadx(double r, double h, double y) {
  double d = sqrt((r*r) - pow((y * r / h),2));
	return d;
}
double _quady(double r, double h, double x)
{
	double d = sqrt((r * r - x * x));
	d *= (h / r);  
	return d;
}
char *gettok(char *d, int t, int sep) {
	int i = 0;
	// throw on the stack for calls like gettok(gettok())
	// otherwise failure for *d == *outt
	char str[1024];
	char *p;
	const char *a = (const char *)&sep;
	static char outt[1024];
	sprintf(str, "%s", d);
  p = strtok(str, a);
  while (p != NULL) {
		i++;
		if (i == t) { sprintf(outt, "%s", p); break; }
    p = strtok(NULL, a);
	}
	return outt;
}
int __stdcall drnd(HWND mWnd,
					  HWND aWnd,
					  char *data,
					  char *parms,
					  BOOL print,
					  BOOL nopause)
{
	if (data) {
		double da = atof(data), d;
		int ib = atoi(gettok(data,2,32)), i = 0;
		if (ib == 0) {
			/*
			d = da - floor(da);
			if (da < 0.0) d -= 1.0;
			if (fabs(d) > 0.4999999999) {
				if (da > 0.0) da += 1;
			}
			else if (da < 0.0) da += 1;
			sprintf(data,"%.1f",floor(da));
			*/
			d = fabs(da) - floor(fabs(da));
			if (d > 0.4999999999) d = fabs(da) + 1;
			else d = fabs(da);
			if (da < 0.0) d = floor(d) * -1;
			else d = floor(d);
			sprintf(data,"%.1f",d);
			return 3;
		}
		if ((int)strlen(gettok(gettok(data,1,32),2,46)) <= ib)
			sprintf(data,"%.15f",da);
		else {
			if (ib < 0) ib *= -1;
			if (ib > 9) ib = 9;
			if (ib <= 6)
			sprintf(data,"%.6f",rround(da,ib));
			if (ib == 7)
			sprintf(data,"%.7f",rround(da,ib));
			if (ib == 8)
			sprintf(data,"%.8f",rround(da,ib));
			if (ib == 9)
			sprintf(data,"%.9f",rround(da,ib));
		}

		for (i=strlen(data);i>0;i--) {
			if (data[i] == '0') data[i] = 0; // book says '/0' but '\0' accepted
			if (data[i-1] != '0') break; // NULL macro or 0 accepted
			if (data[i-2] == '.') break;
		}
		i = strlen(data);
		while ((int)strlen(gettok(data,2,46)) > (ib+1)) {
			data[i] = NULL;
			i--;
		}
		return 3;
	}
	return 0;
}
double rround(double a, int b) {
	int c = (int)pow(10,b);
	double dd = 0.5 / c;
	//if (a < 0.0) dd = -0.5 / c;
	dd+=fabs(a);
	dd*=c;
	/*(int)6378153966.1000004
2083.18667
2083186670.0

floor(6378153966.1000004)
6378153966.0
*/
	//return floor(dd);
	//dd=(int)dd;fails
	//return dd;

	dd=floor(dd);
	dd/=c;
	if (a < 0.0) dd*=-1;
	return dd;
}
int __stdcall drotate(HWND mWnd,
					  HWND aWnd,
					  char *data,
					  char *parms,
					  BOOL print,
					  BOOL nopause)
{
	double sc[2], a[3], p[3];
	if (data) {
		sc[0] = atof(data);
		sc[1] = atof(gettok(data,2,32));
		a[0] = atof(gettok(data,3,32));
		a[1] = atof(gettok(data,4,32));
		a[2] = atof(gettok(data,5,32));
		p[0] = atof(gettok(data,6,32));
		p[1] = atof(gettok(data,7,32));
		p[2] = atof(gettok(data,8,32));
		rotate(sc,a,p);
		sprintf(data,"%f %f %f",p[0],p[1],p[2]);
		return 3;
	}
	return 0;
}
int __stdcall drotation(HWND mWnd,
					  HWND aWnd,
					  char *data,
					  char *parms,
					  BOOL print,
					  BOOL nopause)
{
	double a[3], p[3], r;
	if (data) {
		r = atof(data);
		a[0] = atof(gettok(data,2,32));
		a[1] = atof(gettok(data,3,32));
		a[2] = atof(gettok(data,4,32));
		p[0] = atof(gettok(data,5,32));
		p[1] = atof(gettok(data,6,32));
		p[2] = atof(gettok(data,7,32));
		rotation(atof(data),a,p);

		sprintf(data,"%f %f %f",p[0],p[1],p[2]);
		return 3;
	}
	return 0;
}
void rotate(double sc[2], double axis[3], double point[3]) {
	double mag, s, c;
	double x, y, z, xx, yy, zz, xy, yz, zx, xs, ys, zs, one_c;
	s = sc[0];
	c = sc[1];
	mag = VLEN(axis);
	if (mag == 0.0) mag = 1.0;
	x = axis[0] / mag;
	y = axis[1] / mag;
	z = axis[2] / mag;

	xx = x * x;
	yy = y * y;
	zz = z * z;
	xy = x * y;
	yz = y * z;
	zx = z * x;
	xs = x * s;
	ys = y * s;
	zs = z * s;
	one_c = 1.0 - c;

	x = point[0] * ((one_c * xx) + c);
	y = point[0] * ((one_c * xy) - zs);
	z = point[0] * ((one_c * zx) + ys);

	x += point[1] * ((one_c * xy) + zs);
	y += point[1] * ((one_c * yy) + c);
	z += point[1] * ((one_c * yz) - xs);

	x += point[2] * ((one_c * zx) - ys);
	y += point[2] * ((one_c * yz) + xs);
	z += point[2] * ((one_c * zz) + c);

	point[0] = x;
	point[1] = y;
	point[2] = z;
}
void rotation(double angle, double axis[3], double point[3]) {
	double mag, s, c;
	double x, y, z, xx, yy, zz, xy, yz, zx, xs, ys, zs, one_c;
	s = sin(angle);
	c = cos(angle);
	mag = VLEN(axis);
	if (mag == 0.0) mag = 1.0;
	x = axis[0] / mag;
	y = axis[1] / mag;
	z = axis[2] / mag;

	xx = x * x;
	yy = y * y;
	zz = z * z;
	xy = x * y;
	yz = y * z;
	zx = z * x;
	xs = x * s;
	ys = y * s;
	zs = z * s;
	one_c = 1.0 - c;

	x = point[0] * ((one_c * xx) + c);
	y = point[0] * ((one_c * xy) - zs);
	z = point[0] * ((one_c * zx) + ys);

	x += point[1] * ((one_c * xy) + zs);
	y += point[1] * ((one_c * yy) + c);
	z += point[1] * ((one_c * yz) - xs);

	x += point[2] * ((one_c * zx) - ys);
	y += point[2] * ((one_c * yz) + xs);
	z += point[2] * ((one_c * zz) + c);

	point[0] = x;
	point[1] = y;
	point[2] = z;
}
double radang3(double v[3], double v2[3], double v3[3]) {
  // input is 3 points in 3D -- points to 2 and 3, angle at 1
	double a[3], b[3], r = 0.0;
  SUBV(a,v2,v); SUBV(b,v3,v);
	NORMALIZE(a); NORMALIZE(b);
	r = DOTPRODUCT(a,b);
	CLAMP(r, -1.0, 1.0);
	r = acos(r);
  return r;
}
double radang(double v[3], double v2[3]) {
	double r = 0.0;
	NORMALIZE(v); NORMALIZE(v2);
	r = DOTPRODUCT(v,v2);
	CLAMP(r, -1.0, 1.0);
	r = acos(r);
 	return r;
}
/////////////////////////////////////////////////////////////////////////////
// The one and only CMeshviewApp object

CMeshviewApp theApp;
